/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/
 
 
// This program deletes the Audit Log data.
// Audit log details can be filtered on following parameter.
// 1) From date
// 2) To date 
// 3) for a particular  reportName
// 4) for a particular  userName
// 5) for a particular  reportId
// 6) for a particular  categoryId	 

// Any of these values can be passed as null

// Import Section
// Use intellica jar to import these classes
 
import com.intellica.client.init.ReportClient; 		// Has Init Method
import com.intellica.client.common.Enums;
import com.intellica.client.common.Filter;
import com.intellica.client.common.UserInfo;  		// user info bean 
import com.intellica.client.audit.AuditManager;		// Has Audit log methods
import com.intellica.client.exception.AuditManagerException;//This Exception class is used for all Audit use cases.This class has many constructors with the option of log and no log exceptions. 

import java.util.Date;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class deletes the Audit log details.It is required to provide 
//the report name corresponding to which the audit log details would be deleted.
public class DeleteAuditLog
{

	public static void main(String args[])
	{
		
		try
		{
						
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// prepare parameters for filtering
			Date fromDate		=null;//new Date(2006-1900 ,2-1,01);
			//System.out.print(fromDate);
			Date toDate			=null;//new Date(2006-1900,3-1,9);//new Date(106,0,1);
			String reportName	=null;//"Product";//"Bank_Rep";
			String userName		=null;//"Admin";
			String categoryId 	=null;;//"Test";
			String reportId 	=null;//"91FEE269-3AEE-C23D-6F04-7A9979BEBE09";
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
									
			// Create a Audit Manager controller class object for audit management related operations
			AuditManager am= new AuditManager();
            Filter filter=new Filter();
			
			//The method set the key,value pair for a particular filter field
			//public void setFilterField(java.lang.String filterKey,java.lang.Object filterValue)
			//@Param filterKey - takes String value.
            //@Param filterValue - takes Object value.
			filter.setFilterField(Enums.Filters.AuditLog.REPORTNAME,reportName);
			filter.setFilterField(Enums.Filters.AuditLog.CATEGORYID,categoryId);
			filter.setFilterField(Enums.Filters.AuditLog.FROMDATE,fromDate);
			filter.setFilterField(Enums.Filters.AuditLog.TODATE,toDate);
			filter.setFilterField(Enums.Filters.AuditLog.REPORTID,reportId );
			filter.setFilterField(Enums.Filters.AuditLog.USERID,userName);
			
			 		
			// this method will return an ArrayList of Audit Log details for the specified filters
			// any of these value can be passed as null
			
			
			// this method will delete Audit Log details for the specified filters
			// any of these value can be passed as null
			try
			{
				//method will delete audit log information
                //public void deleteAuditLogList(Filter filter,UserInfo userInfo)
                //                                  throws AuditManagerException
				//@param filter - Filter which can take request filters from Enums.Filters.AuditLog
				//@param userInfo - : The User Information Object 

				am.deleteAuditLogList(filter,requestorUserInfo);
				System.out.println("Audit details deleted");
			}
			catch(AuditManagerException ame)
			{
				System.out.println ("Failed to delete audit details:"+ame.getExtMessage());
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}		
