/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/
 
 
// This program returns Audit Log data.
// Audit log details can be filtered on following parameter.
// 1) From date
// 2) To date 
// 3) for a particular  reportName
// 4) for a particular  userName
// 5) for a particular  reportId
// 6) for a particular  categoryId	 

// Any of these values can be passed as null

// Import Section
// Use intellica jar to import these classes
 
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;


import com.intellica.client.audit.AuditLogData;//This bean class stores information about a audited report output 
import com.intellica.client.audit.AuditManager;//This is the controller class for all operations related to audit
                                              //log. The class provides method which acts as an interface for 
                                              //sending diffrent requests related to audit log to report engine from the jsps.
import com.intellica.client.common.Filter;//This class hold information about Filter applied 
import com.intellica.client.common.InteraConstants;//This class contains all the Constants used in Reporting System
import com.intellica.client.common.UserInfo;//user info bean 
import com.intellica.client.exception.AuditManagerException;//This Exception class is used for all Audit use cases.
import com.intellica.client.init.ReportClient;//Has Init Method
import com.intellica.client.reportutils.FilterParams;//This is wrapper class for Adhoc filters
import com.intellica.client.common.Enums;

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

public class GetAuditDetail
{

	public static void main(String args[])
	{
		
		try
		{
						
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// prepare parameters for filtering
			Date fromDate		=null;//new Date(2006-1900 ,2-1,01);
			Date toDate			=null;//new Date(2006-1900,3-1,9);//new Date(106,0,1);
			String reportName	=null;//"Product";//"Bank_Rep";
			String userName		=null;//"Admin";
			String reportId 	=null;//"91FEE269-3AEE-C23D-6F04-7A9979BEBE09";
			String categoryId 	=null;;//"Test";
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
				
			ArrayList arrayList 	= new ArrayList();
			
			// Create a Audit Log Data class object for receiving audit details
			AuditLogData auditData	=new AuditLogData();
						
			// Create a Audit Manager controller class object for audit management related operations
			AuditManager am= new AuditManager();
			Filter filter=new Filter();
			
			//The method set the key,value pair for a particular filter field
			//public void setFilterField(java.lang.String filterKey,java.lang.Object filterValue)
			//@Param filterKey - takes String value.
            //@Param filterValue - takes Object value.
			filter.setFilterField(Enums.Filters.AuditLog.REPORTNAME,reportName);
			filter.setFilterField(Enums.Filters.AuditLog.CATEGORYID,categoryId);
			filter.setFilterField(Enums.Filters.AuditLog.FROMDATE,fromDate);
			filter.setFilterField(Enums.Filters.AuditLog.TODATE,toDate);
			filter.setFilterField(Enums.Filters.AuditLog.REPORTID,reportId );
			filter.setFilterField(Enums.Filters.AuditLog.USERID,userName);
			
			// this method will return an ArrayList of Audit Log details for the specified filters
			// any of these value can be passed as null
			try
			{
			//Method to get list containing audit log information
		    //public java.util.ArrayList getAuditLogList(Filter filter,UserInfo userInfo)
            //                                                throws AuditManagerException
			//@param filter - Filter which can take request filters from Enums.Filters.AuditLog
			//@param userInfo - UserInfo for authorization. 
			   arrayList=am.getAuditLogList(filter,requestorUserInfo);				
			}
			catch(AuditManagerException ame)
			{
				System.out.println ("Failed to retrieve audit details ");
			}
					
			for(int i=0;i<arrayList.size(); i++)
			{
				auditData=(AuditLogData)arrayList.get(i);
				//Gives the name of the report in the audit log list
				reportName=auditData.getReportName();
				System.out.println ("Report Name  "+reportName);
				//Gives the Report Id
				String reportID= auditData.getReportID();
				System.out.println("Report ID: "+reportID);
				//Give the Category ID
				String categoryID=auditData.getCategoryID();
				System.out.println("Category ID: "+categoryID);				
				//Gives the timestamp of the report in the audit log list
				String timeStamp=auditData.getTimeStamp();
				System.out.println ("Time Stamp : "+timeStamp);
				//Gives the name of the user who performed any action on the report in the audit log list
				userName=auditData.getUserName();
				System.out.println ("User Name: "+userName);
				//Gives the Report Format of the report in the audit log list
				String reportFormat=auditData.getFormat();
				System.out.println ("reportFormat: "+reportFormat);
				//Gives the time taken by the report, to be generated or other actions being performed 
				//on the report that is in the audit log list	
				String operationTimeSpent=auditData.getOpTimeSpent();
				System.out.println ("Time Spent: " + operationTimeSpent); 
				//Gives the action that is done on the report in the audit log list
				String action=auditData.getAction();
				System.out.println ("Action: "+action);
				//Gives the report output id of the report
				String reportOutputID=auditData.getReportOID();
				System.out.println ("reportOutputID: "+reportOutputID);
				//Gives the status of the report
				String status=auditData.getStatus();
				System.out.println ("Status: "+status);
				//Gives description(if any) of the report
				String description=auditData.getDescription();
			    System.out.println ("description: "+description);
			    //Gives the report Audit detail ID
			    String reportAuditDetailId=auditData.getReportAuditDetailId();
			    System.out.println("ReportAuditDetailId: "+reportAuditDetailId); 
				//Gives the report parameters information
				HashMap paramsinfo= auditData.getReportParams();
				System.out.println ("HashMap of Report Params:"+paramsinfo);				
				// Getting Params Info Parameters
				HashMap sysparams = (HashMap)paramsinfo.get(InteraConstants.SYS_PARAMS);
				System.out.println ("SysParams" + sysparams);  
			    //Getting system filter parameters
				String filterCriteria= (String)sysparams.get("SYS_FILTER_PARAMS");
				System.out.println ("Filter Criteria " + filterCriteria); 
				//Getting system parameters related to the report
				String groupBy= (String)sysparams.get("SYS_GROUPBY");
				System.out.println ("Group By " + groupBy); 
			    //Getting report parameters
				HashMap userparams = (HashMap)paramsinfo.get(InteraConstants.REPORT_PARAMS);
				System.out.println ("User Params " + userparams);  
				//getting business parameters of the report
				String businessParam= (String)userparams.get("SALARY");
				System.out.println ("Business Param " + businessParam); 
				//getting sort parameters
				HashMap sortparams = (HashMap)paramsinfo.get(InteraConstants.SORT_PARAMS);
		    	System.out.println ("SortParams" + sortparams);  
				//Getting adhoc parameters
		    	FilterParams adhocparams = (FilterParams)paramsinfo.get(InteraConstants.ADHOC_PARAMS);
				System.out.println ("AdhocParams" + adhocparams);  		       
							
			}
					
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}		
