/* This program uploads and deploy the cab files.
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
// Import Section
// Use intellica jar to import these classes

import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.exception.BaseException;//This class is the base class of all 
                                                   //the application generated exceptions engine may throw. 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.utils.Utility;//The Utility class contains utility methods ,
                                          //which are used in the application
import com.intellica.client.layout.cabHandler.*;//for the operations an to access the classes of Report Deployer
import java.io.File;//An abstract representation of file and directory pathnames
import java.io.FileInputStream;//For reading streams of raw bytes such as image data. 
                               //For reading streams of characters, consider using FileReader.

import 	java.io.BufferedInputStream;
import 	java.io.InputStream;

/**
 * Class to upload and deploy cab file.
 * The changes that needs to be done in order to run are as follows
    Update the correct path of ReportClient.properties file. (to connect to server)
    provide Super Admin credentials in userInfo object (Only super Admin can deploy cab files)
    Update applicationPath variable to the actual path where intellicus web client is deployed ( intellicus web Client path is needed to upload some files like themes, plugins etc.)
    update cabFilePath variable  to the actual path where cab file is placed (Cab file path)
*/
public class CabDeployer {

	
	public static void main(String args[]){
		try{
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
				ReportClient.init(is);

			//user credentails of super admin
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			CabDeployer cabDeployer = new CabDeployer();
			//path where the intellicus web client is deployed
			String applicationPath = "C:/Program Files/Intellicus/Jakarta/webapps/intellicus";
			//actual path of cab file
			
			String cabFilePath = "c:/abc.irb";
			//now start the upload and deployment process.
			cabDeployer.deployCabFile(cabFilePath,requestorUserInfo,applicationPath);
			
		}catch (Exception e) {
			e.printStackTrace();
			
		}
	}
	
	
	public void deployCabFile(String cabFilePath,UserInfo requestorUserInfo,String applicationPath ){
		try{
		CabFile.setApplicationPath( applicationPath + File.pathSeparator); 
		//this is to upload cab file 
        CabFile  cabFileObj  = new CabFile(cabFilePath,requestorUserInfo); 
        System.out.println("Cab File uploaded successfully*******");
		//now deploy the uploaded cab file
        //public java.util.HashMap deploy(java.lang.String cabPath,UserInfo userInfo)
        //                 throws BaseException
        
        cabFileObj.deploy(cabFilePath, cabFilePath+".log" ,requestorUserInfo);
        System.out.println("Cab File deployed successfully*******");
		//finally read the deployment log file
        //public static byte[] readFile(java.lang.String filePath)  throws BaseException
        
        byte[]  logBytes = Utility.readFile(cabFilePath+".log"); 
        System.out.println("Cab file deployment log " + new String(logBytes));
		}catch (BaseException be) {
			System.out.println("Invalid file format for the deployment file");
		}

	}
}
