//This program is to create a new category.
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

//// Import Section
// Use intellica jar to import these classes
import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used 
                                                             //for all Layout use cases.
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;//For all report layout operations 
                                                 //client creates the object of this class.
												 //The methods of this class are stateless 
												 //and takes all required information such 
												 //as requestor User Info etc. in each call.
import com.intellica.client.reportutils.Category;//This class represents the Report Category.
                                                 //This class provides category attributes. 

import 	java.io.FileInputStream;
import 	java.io.BufferedInputStream;
import 	java.io.InputStream;

//This class creates a new category and adds it to the Intellicus Repository.
public class CreateNewCategory 
{
	public static void main(String args[])
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm= new LayoutManager();
			
			String catName="ChildCategory";
			Category newCategory=new Category(catName);
			newCategory.setIsPublic(true);
			newCategory.setIsHidden(false);
			newCategory.setDescription("This is the new category just created");
			//Set the parent category inside which, the new Category is to be added.
			//If not set, then the new Category is added at Root folder.
			newCategory.setParentCategoryId("Level2");
			//To set the category id manually, otherwise, it takes system generated Category Id.
			newCategory.setCategoryId("ChildCategory");
			newCategory.setMenuName(catName);
			
			//Adds new category to the Intellicus repository.
			//Syntax: public Category addCategory(Category category,UserInfo userInfo)
			lm.addCategory(newCategory,requestorUserInfo);
		}catch (LayoutHandlerException lhe){
			System.out.println ("ErrorMessage: "+lhe.getMessage());
			System.out.println ("RootCause	 : "+lhe.getRootCause());
		}catch(Exception e){
		  e.printStackTrace();
		}
	}

}
