//This Java API is used to delete an Existing Category from the Intellicus repository along with the Reports present in that Category.
//User need to provide the Category ID of the Category which is to be deleted.
//This would require user to provide UserInfo to authorize for Reports related Activites.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used
                                                             //for all Layout use cases.This 
															 //class has many constructors with
															 //the option of log and no log exceptions. 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;//For all report layout operations 
                                                 //client creates the object of this class.
												 //The methods of this class are stateless 
												 //and takes all required information such 
												 //as requestor User Info etc. in each call.
import 	java.io.FileInputStream;
import 	java.io.BufferedInputStream;
import 	java.io.InputStream;

/**
 * 
 * This class is used for deleting an existing category from the report layout repository. 
 */
public class DeleteCategory {
	public static void main(String args[])
	{
		try
		{
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
	
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			
			//Category ID of the Category that is to be deleted.
			String categoryID="TestCategory";
						
			//Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			
			//This method is used to delete the existing category from the report 
			//engine's report layout repository along with the reports contained in it. 
			
			//@param 1 : Category ID of the Existing Category that is to be deleted.
			//@param 2 : UnConditional - If true than deletes the category even there are any report layouts present in the category along with allits reports.
			//@param 3 : userInfo - UserInfo object authorization.
			lm.deleteCategory(categoryID, true,requestorUserInfo);
		}
		catch (LayoutHandlerException lhe)
		{
			System.out.println ("ErrorMessage: "+lhe.getMessage());
		    System.out.println ("RootCause	 : "+lhe.getRootCause());
		}        
	   catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
