/* This program 
 * 1) Creates a userinfo Object of Super admin User.
 * 2) Get all report present in the given Category from the report server
 *User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


// Import Section
// Use intellica jar to import these classes
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;

import com.intellica.client.common.Filter;
import com.intellica.client.common.UserInfo;// user info bean 
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used for all Layout use cases.
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;// for report layout management related operations		
import com.intellica.client.reportutils.Category;//This Exception class is used for all Layout use cases.

import 	java.io.FileInputStream;
import 	java.io.BufferedInputStream;
import 	java.io.InputStream;

//This class retrieves the list of sub-categories prsent in the given Category from the Intellicus repository.
public class GetSubCategoriesForCategory {
	public static void main(String arg[]){
		
		try
		{
		
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm= new LayoutManager();

			//Category Id whose sub categories are to be obtained
			String catId = "4F9245A7-D639-4F99-604D-F32641B77725";
			Category categoryObj = null;
			
			try{
				//getting category object corresponding to given category id.
				categoryObj = lm.getCategory(catId, requestorUserInfo);
			
				//now, fill the sub-categories in the category object.
				Filter filter = new Filter();
				filter.setFilterField("ENTITYTYPE", "CATEGORY");
				lm.populateEntityListForCategory(categoryObj, filter, requestorUserInfo);
				
			}catch(LayoutHandlerException lhe){
			    System.out.println ("ErrorMessage: "+lhe.getMessage());
			    System.out.println ("RootCause	 : "+lhe.getRootCause());
			}

			//get the sub-categories LinkedhashMap.
			LinkedHashMap subcategories = categoryObj.getSubCategories();
			
			System.out.println(" Parent Category Name = "+categoryObj.getMenuName());		
			
			//iterating through the LinkedHashMap to get the sub-categories
			if(subcategories != null){
	            Set keySet = subcategories.keySet();
	            Iterator itr = keySet.iterator();
	            while(itr.hasNext()){
	                String categoryId = (String) itr.next();
	                Category category = (Category) subcategories.get(categoryId);
	                System.out.println(" Sub-Category Name = "+category.getMenuName());
	            }
	        }
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
