
//This Java API is used to delete the Dashboard from the Intellicus Repository.
//This would require User to provide the Dashboard ID i.e. to be deleted
//This would require user to provide UserInfo to authorize for Dashboard related activity.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
 
 
// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Delete the dashboard whose dashboard Id is given.

// Import Section
// Use intellica jar to import these classes
import java.util.ArrayList;
import java.util.Iterator;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

import com.intellica.client.common.Enums;
import com.intellica.client.common.Filter;
import com.intellica.client.common.UserInfo;
import com.intellica.client.dashboard.Dashboard;
import com.intellica.client.dashboard.DashboardManager;
import com.intellica.client.dashboard.DashboardPreference;
import com.intellica.client.dashboard.DashboardPreferences;
import com.intellica.client.exception.DashboardException;
import com.intellica.client.init.ReportClient;

//This class is used to delete the dashboard with given Dashboard Id from the Report Server.
//The user would require to provide the DashBoard ID and its identity i.e logged-in User's Credentials.
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Provide the Category ID whose Reports are to be listed
//3) Get all reports from the report server
public class DeleteDashboard {
	public static void main(String args[])
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user must have Dashboard rights to perform Dashboard management activities
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "John";
			String password = "John";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
		    DashboardManager dManager = new DashboardManager();
		    
			//Dashboard Id of the Dashboard i.e. to be deleted from the Repository
		    String dashBoardId = "C7EB76EC-394B-1E05-8DEA-CAA267F9CE0F";

			//This method is used to delete the dashboard specified by the dashboard ID passed as an argument.
			//@param dashboardId : The unique identifier of the dashboard to be deleted.
			//@param userInfo {@link com.intellica.client.common.UserInfo userInfo} object for authorization.
     	    dManager.deleteDashboard(dashBoardId, requestorUserInfo);
		    
		}catch(DashboardException de)
		{
			de.printStackTrace();
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
