

//This Java API is used to get the complete detail about the Dashboard like its Category, Description, Access Rights etc
//This would require User to provide the Dashboard ID whose detail is to be obtained
//This would require user to provide User credentials for authorizing for dashboard related activities

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
 
 
// This program 
// 1) Create a userinfo Object of current logged in User.
// 2) Provide Dashboard Id whose detail is to be obtained

// Import Section
// Use intellica jar to import these classes
import java.util.ArrayList;
import java.util.Iterator;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

import com.intellica.client.common.Enums;
import com.intellica.client.common.Filter;
import com.intellica.client.common.UserInfo;
import com.intellica.client.dashboard.Dashboard;
import com.intellica.client.dashboard.DashboardManager;
import com.intellica.client.exception.DashboardException;
import com.intellica.client.init.ReportClient;

//This class is used to get the detail about the given Dashboard.
//The user would require to provide the Dashboard ID and its identity i.e UserInfo. 
//The required steps are :  
//1) Create a userInfo Object of the User.
//2) Provide the Dashboard ID for getting its details
public class GetDashboardDetails {
	public static void main(String args[])
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			//This class used for Dashboard related settings.
			//It exposes all the public APIs related to dashboard package
		    DashboardManager dManager = new DashboardManager();
		    
			ArrayList dashBoardList = new ArrayList();
		    
			//Dashboard Id of the dashboard whose details are to be obtained
			String DashboardId = "9678EAF1-1B6E-5BB8-E7A8-2118D15C0709";
		  
			//This method is used to get the requested DashBoard Object whose ID is passed as an argument.
			//@param dashboardId: The unique identifier of the dashboard for which the details are to be obtained from the Report Server.
			//@param userInfo:  {@link com.intellica.client.common.UserInfo userInfo} object for authorization to get DashBoard..
			//@return Dashboard {@link com.intellica.client.dashboard.DashBoard2 DashBoard2} object containing dashboard details
			Dashboard dashboard = dManager.getDashBoardDetails(DashboardId, requestorUserInfo);
		    
	    	System.out.println("Dashboard's Name = "+dashboard.getPatternName());
	    	System.out.println("Dashboard's Category = "+dashboard.getCategoryName());
	    	System.out.println("Public Dashboard = "+dashboard.getIsPublic());
	    	System.out.println("Dashboard's Access Rights = "+dashboard.getAccessRights());
	    	System.out.println("Dashboard's Description = "+dashboard.getDescription());

		}catch(DashboardException de)
		{
			de.printStackTrace();
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
