package defaultPackage;

//This Java API is used to delete existing Entities, say Categories, here.
//This would require user to provide UserInfo to authorize for performing Category related activities.
//User need to provide the Category Ids of the Categories that are to be deleted.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;

import com.intellica.client.common.EntityOperation;
import com.intellica.client.common.UserInfo; // Object used to pass in run report
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             //in initializing the report Engine interface (REInterface). 
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used for all Layout use cases.
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;// for report layout management related operations			

/**
 * 
 * This class is used to delete existing Entities (Categories) whose Entitity Ids are provided.  
 */
public class DeleteEntities 
{
	public static void main(String arg[])
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            // @param userId   - : Id of the User Logged-In.
            // @param password - : Password of the User Logged-In.
            // @param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
						
					
			// Create a Layout Manager class object 
			// for layout management related operations			
			LayoutManager lm= new LayoutManager();
			
			String categoryIds[] = new String[]{"Sales_Category", "Invoice_Cat", "1B463044-61BF-D344-7264-B85CD2AEDC9D"};
			
			//Arraylist to store Category Objects
			ArrayList entityList = new ArrayList();
			EntityOperation entityObj = null;
			
			for(int i=0;i<categoryIds.length;i++){
				entityObj = new EntityOperation();
				entityObj.setEntityType("CATEGORY");
				entityObj.setEntityId(categoryIds[i]);
				entityList.add(entityObj);
			}
			// Method to delete the Entities from Repository
			// @param 1 : entityList - Arraylist containing Entity(Category) Objects
			// @param 2 : requestorUserInfo - UserInfo object for authorization. 
			lm.deleteEntities(entityList, requestorUserInfo);
			
		}
		catch(InterfaceInitException iie)
		{
			System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		}
		catch(LayoutHandlerException lhe)
		{
			lhe.printStackTrace();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}	
}		
		
		
		
		
		
		
		
	
    
	

