package defaultPackage;

//This Java API is used to move  existing Entities, say Query Objects here, to another Destination Category.
//This would require user to provide UserInfo to authorize for performing Reports related activities.
//User need to provide the Query Ids that are to be moved and the Destination Category ID where they are to be Copied.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;

import com.intellica.client.common.EntityOperation;
import com.intellica.client.common.UserInfo; // Object used to pass in run report
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             //in initializing the report Engine interface (REInterface). 
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used for all Layout use cases.
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;// for report layout management related operations			

/**
 * 
 * This class is used to move existing Query Objects to another destination Category with 
 * given Category ID 
 */
public class MoveEntities
{
	public static void main(String arg[])
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			// Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            // @param userId   - : Id of the User Logged-In.
            // @param password - : Password of the User Logged-In.
            // @param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
		
						
			// Create a Layout Manager class object 
			// for layout management related operations			
			LayoutManager lm= new LayoutManager();
			
			//Category ID of the Destination Category where the Entities(Query Objects) are to be Moved.
			String destCategoryId = "Sales_category";
			
			String queryIds[] = new String[]{"12607729345009203129192910671882", "12603516809689203129192914431495"};
			
			//Arraylist used to store entity objects.
			ArrayList entityList = new ArrayList();
			
			EntityOperation entityObj = null;
			
			for(int i=0;i<queryIds.length;i++){
				entityObj = new EntityOperation();
				//Entity Type could be REPORT /CATEGORY /QUERY /DASHBOARD2/
				//PARAMETER /SAVEDREPORT /DASHBOARD_WIDGET /CUBEOBJECT
				entityObj.setEntityType("QUERY");
				entityObj.setEntityId(queryIds[i]);
				entityList.add(entityObj);
			}
			// Method to move the Entities(Query Objects) to another Category
			// @param 1 : entityList : Arraylist containing Query Objects that are to be moved  
			// @param 2 : destinationCategoryId - destination category id,where queries are to be moved.
			// @param 3 : requestorUserInfo - UserInfo object for authorization. 
			lm.moveEntities(entityList, destCategoryId, requestorUserInfo);
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
			iie.printStackTrace();
		}
		catch(LayoutHandlerException lhe)
		{
			lhe.printStackTrace();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}	
}		
		
		
		
		
		
		
		
	
    
	

