// This program adds a new organisation and sets the authentication mode.
//The user would require to provide its identity i.e. user Info to authorize for creating Organization..

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/

// Import Section
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

// Use intellica jar to import these classes
import com.intellica.client.security.SecurityManager;//for getting the controller information for all Administration related operations
import com.intellica.client.common.UserInfo;//For getting user information
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
														 //or if read or write operation cant be performed from or to the engine
														 //or If some error has occured while executing the request on the engine.
                                                         //or If the response xml obtained from server cannot be parsed 

import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.security.OrgInfo;//Used for getting organisation information>
import com.intellica.client.security.Authentication;// Used for setting Authentication mode 

//This class 
// 1) Creates a userinfo Object of current logged in User.
// 2) Sets Host authentication mode for the organization.
// 2) Add an organization in the Intellicus application.

public class AddOrg
{ 

	public static void main(String args[])
	{
		
			try{
				
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
			
				
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application.
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
                //@param userId   - : Id of the User Logged-In.
                //@param password - : Password of the User Logged-In.
                //@param orgId    - : Organization Id from which User Logged-In.
				String userId = "Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo requesterUserInfo = new UserInfo(userId,password,organization);
				
				// Create a SecurityManager class object 
			    // for getting the controller information for all Administration related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr=SecurityManager.getInstance();
			
				
				// Create an OrgInfo object by setting organization Id.
				String organisationId="Test";
				OrgInfo addOrg=new OrgInfo(organisationId);
				
				// Set authentication mode for the organization.
				// Set authentication mode as Host if authentication check is performed by main application.
				// for single sign-on 
				
				Authentication authInfo = new Authentication();
				//public void setAuthenticateMode(int authenticateMode)
				//Authentication Mode Id values 1=Host Application
				//                              2= Intellica
				//                              3=External Application.
				//This identifies who will authenticate the users/roles belonging to this organization. 
                //@param authenticateMode - Authentication Mode Id's value

				authInfo.setAuthenticateMode(com.intellica.client.common.Enums.SecurityTypes.Authentication.HOSTAPP);
				//public void setAuthenticationObj(Authentication authentication)sets the Authentication object.
				//Authentication object keeps the data of tag attributes and data of inner tag . 
                //@param  authInfo -object of Authentication class
				addOrg.setAuthenticationObj(authInfo);
			
				// This will send request to the server for adding organization.
				//Syntax - public void addOrganization(OrgInfo orgInfo,UserInfo userInfo)
				//                                    throws ISecurityException
                //@param orgInfo - The Organization details
                //@param userInfo - The User details 
				sMgr.addOrganization(addOrg,requesterUserInfo);
					
				}
				catch(ISecurityException ise)
				{
				System.out.println("Failed to add the organization as the organization with " +
						"the same id must be existing");
				
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}		
	
}
}		
