// This program is to delete an organization from the Intellicus repository.
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/


// Import Section
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

// Use intellica jar to import these classes
import com.intellica.client.security.SecurityManager;//for getting the controller information for all Administration related operations
import com.intellica.client.common.UserInfo;//For getting user information
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
														 //or if read or write operation cant be performed from or to the engine
														 //or If some error has occured while executing the request on the engine.
                                                         //or If the response xml obtained from server cannot be parsed 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.security.OrgInfo;//Used for getting organisation information>

//This class deletes an existing organisation from the Intellicus repository.The user requesting for deleting the organization 
//should have the rights to delete the organization and is required to provide the organisation id.
public class DeleteOrg
{

	public static void main(String args[])
	{
		
			try{

				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
					
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application and should have the rights to delete the organisation.
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
                //@param userId   - : Id of the User Logged-In.
                //@param password - : Password of the User Logged-In.
                //@param orgId    - : Organization Id from which User Logged-In.

				String userId = "Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo requesterUserInfo = new UserInfo(userId,password,organization);
				
				// Create a SecurityManager class object 
			    // for getting the controller information for all Administration related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr=SecurityManager.getInstance();
			
				//This gets Organization which is to be deleted	
				//Syntax :public OrgInfo getOrganizationById(java.lang.String orgId,UserInfo userInfo)
                //@param orgId - Id of the requested OrgInfo object
				//@param userInfo - The current user details 
				String organizationId="Test";
				OrgInfo delOrg=sMgr.getOrganizationById(organizationId,requesterUserInfo);
			
				//This  Deletes the Organization from the Intellicus Repository.
				//Syntax :public void deleteOrganization(OrgInfo orgInfo,UserInfo userInfo)
				//                                       throws ISecurityException
                //@Param orgInfo  : The Organization details
                //@param userInfo : The current user details
				sMgr.deleteOrganization(delOrg,requesterUserInfo);
			
				}
				catch(ISecurityException ise)
				{
					System.out.println("The Organization with given details was not found");
				}
			catch(Exception e)
			{
				e.printStackTrace();
			}		
	} // End of main function
	
}		
