// This program is to get organization by passing organization Id. 
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/
// Import Section
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

// Use intellica jar to import these classes
import com.intellica.client.security.Authentication;
import com.intellica.client.security.SecurityManager;//for getting the controller information for all Administration related operations
import com.intellica.client.common.UserInfo;//For getting user information
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
														 //or if read or write operation cant be performed from or to the engine
														 //or If some error has occured while executing the request on the engine.
														 //or If the response xml obtained from server cannot be parsed 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.security.OrgInfo;//Used for getting organisation information>

//This class is to get the organisation by passing the organisation id.
//This class also retrieves information about an existing organisation and 
//several operations can be performed on that organisation.
public class GetOrgById
{

	public static void main(String args[])
	{
		
			try{

				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
			
				
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application.
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
                //@param userId   - : Id of the User Logged-In.
                //@param password - : Password of the User Logged-In.
                //@param orgId    - : Organization Id from which User Logged-In.

				String userId = "Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo requesterUserInfo = new UserInfo(userId,password,organization);
				
				// Create a SecurityManager class object 
			    // for getting the controller information for all Administration related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr=SecurityManager.getInstance();
							
                //This will get the Information about any existing organisation Organization.	
				//Syntax:public OrgInfo getOrganizationById(java.lang.String orgId,UserInfo userInfo)
				//                                                          throws ISecurityException
                //@param orgId    : Id of the requested OrgInfo object
                //@param userInfo : The current user details 
                String organisationId="Test";
				OrgInfo orgObj=sMgr.getOrganizationById(organisationId,requesterUserInfo);
				System.out.println ("OrganizationName: "+orgObj.getOrgId());
				//This will get the description about the description.
				System.out.println ("OrganizationDescription: "+orgObj.getOrgDescription());
				//This will get the mapping type used in the given organization.
				//Syntax public int getMapType()In case the authentication is done 
				//by Host Application this integer value decides what will be the mapping 
				//between users/roles of host application to users/roles of this application.
				//possible values are 1= Application user to Intellica User 
				//                    2=Application user to Intellica Role 
				//                    3=Application role to Intellica User 
				//                    4=Application role to Intellica Role 
				System.out.println ("OrganizationMapType: "+orgObj.getMapType());
				//This will get the Authorization mode of the given organization
				//Syntax public int getAuthorizeMode()
				//AuthorizeMode values 
				//1=Intellica 
				//2=LDAP - Reports are deployed on LDAP server 
				System.out.println ("OrganizationAuthorization mode: "+orgObj.getAuthorizeMode());
				//This will return the authentication object
				//Syntax public Authentication getAuthenticationObj()sets the Authentication object. 
				//Authentication object keeps the data of tag attributes and data of inner tag . 
				//Its required to get the authentication object to get the authentication mode.
				System.out.println ("OrganizationAuthenticationObject: "+orgObj.getAuthenticationObj());
				//An object of authentication class is created.getAuthenticationObj() is called on orgObj that returns
				//an object of authentication class .With the help of the authentication class object get Authentication mode ()
				//method is called that returns the mode of authentication.
				//Syntax public int getAuthenticateMode()Authentication Mode Id values 
				//1= Host Application 
				//2= Intellica
				//3=External Application. 
				//This identifies who will authenticate the users/roles belonging to this organization. 
				Authentication authObj= orgObj.getAuthenticationObj();
			    System.out.println("authObj.getAuthenticateMode()="+authObj.getAuthenticateMode());
			    
			}
			catch(ISecurityException ise)
			{
				System.out.println("Connection cannot be established with the engine or " +
						"read or write operation cant be performed from or to the engine or" +
						"some error has occured while executing the request on the engine or" +
						"If the response xml obtained from server cannot be parsed");
				
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}		
	} // End of main function
}		
 