// This program is to get list of users for the given organization 
//The user would require to provide its identity i.e. user Info to get authorized.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/
// Import Section
// Use intellica jar to import these classes
import com.intellica.client.security.SecurityManager;// Has user management methods
import com.intellica.client.common.UserInfo;// user info bean 
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
														 //or if read or write operation cant be performed from or to the engine
														 //or If some error has occured while executing the request on the engine.
														 //or If the response xml obtained from server cannot be parsed 

import com.intellica.client.init.ReportClient; // Has Init Method
import java.util.ArrayList;//for arrayList operations.
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This will get the list of users for a given organisation.User required to provide the
//organisation id,whose list of users the requesting user wants to retrieve.
public class GetUserListForOrg
{

	public static void main(String args[])
	{
		
			try{
	
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
	
				
				// Prepare a requestor user info bean object.
				// This user must have Admin rights to perform user management actions
				// such as create user
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
                //@param userId   - : Id of the User Logged-In.
                //@param password - : Password of the User Logged-In.
                //@param orgId    - : Organization Id from which User Logged-In.

				String userId = "Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo requestorUserInfo = new UserInfo(userId,password,organization);
				
				// Create a SecurityManager class object 
			    // for getting the controller information for all Administration related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr=SecurityManager.getInstance();
			
				//This Variable is created for getting User List for specified Organization
				ArrayList arrList=new ArrayList();
				String orgId="Intellica";//Get the list of users for this Organization.
				
				//This will get the users list for specified Organization.
				//Syntax public java.util.ArrayList getUserListForOrganization(java.lang.String orgId,
                //UserInfo userInfo)throws ISecurityException
                //@param orgId - of the userInfo list to be retrieved. 
				//@param requestorUserInfo-Information about the user that is requesting for getting 
				//                         the list of users.
                arrList=sMgr.getUserListForOrganization(orgId,requestorUserInfo);
					
				for(int i=0;i<arrList.size();i++)
				{
					int count=i+1;
					UserInfo usr=(UserInfo)arrList.get(i);
					System.out.println("\n\n\nUSER" +count+":"+usr.getUserId());
			}		
				
            }
			catch(ISecurityException ise)
			{
	           System.out.println("The Organization with the given details was not found");
	        }
			catch(Exception e)
			{
				e.printStackTrace();
			}
	} // End of main function
}		
