// This program is to modify the organization details. 
//The user would require to provide its identity i.e. user Info to authorize for modifying Organization..

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/
// Import Section
// Use intellica jar to import these classes
import com.intellica.client.security.Authentication;
import com.intellica.client.security.SecurityManager;//for getting the controller information for all Administration related operations
import com.intellica.client.common.UserInfo;//For getting user information
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
                                                         //or if read or write operation cant be performed from or to the engine
                                                         //or If some error has occured while executing the request on the engine.
                                                         //or If the response xml obtained from server cannot be parsed 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.security.OrgInfo;//Used for getting organisation information>
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class retrieves the organisation as an object modify the organisation details.User required to provide the organisation id,that
//required to be modified.And the user required to have the rights to modify the organisation.
public class ModifyOrg
{

	public static void main(String args[])
	{
		
			try
			{
				
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);

                // Create a SecurityManager class object 
			    // for getting the controller information for all Administration related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr=SecurityManager.getInstance();
			
											
				// Prepare a requestor user info bean object.
			    // This user should be present in Intellicus application.
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
                //@param userId   - : Id of the User Logged-In.
                //@param password - : Password of the User Logged-In.
                //@param orgId    - : Organization Id from which User Logged-In.

				String userId = "Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo requesterUserInfo= new UserInfo(userId,password,organization);
				
				//Method will return the organization having the given orgId to do any kind of modifications on it.
                //Syntax:public OrgInfo getOrganizationById(java.lang.String orgId,UserInfo userInfo)
                //                                                    throws ISecurityException
				//@param orgId    : Id of the requested OrgInfo object
                //@param userInfo : The current user details 
				String organisationId="testOrg";
				OrgInfo modOrg=sMgr.getOrganizationById(organisationId,requesterUserInfo);
			    
			    //Syntax public void setCanDelete(boolean canDelete)
				//@param canDelete - : determines whether organization can be deleted or not.
				//                     The value is true if organization can be deleted else false.
				modOrg.setCanDelete(true);
				// This will update Organization description.
				String description="Modified organization description 3rd time.....";
				modOrg.setOrgDescription(description);
				
				/*
				 * public void setAuthenticateMode(int authenticateMode)
					 *Authentication Mode Id values 
					 *1= Host Application ; 2= Intellica;3=External Application.
					 *
					 * This identifies who will authenticate the users/roles belonging to this
					 * organization.
					 *
					 *@param authenticateMode : Authentication Mode Id's value
				 */		
				Authentication authInfo = new Authentication();
				authInfo.setAuthenticateMode(com.intellica.client.common.Enums.SecurityTypes.Authentication.REPORTINGSYS);
				authInfo.setPWNeverExpires(false);
				/* Set whether the to change password id enforced for the organization 
				 * @param pwdChangeEnforced : values:0/1
				 * 0 for false
				 * 1 for true
				 * public void setPWDChangeEnforced(String pwdChangeEnforced)
				 */
				authInfo.setPWDChangeEnforced("0");
				/*
				 *@param pwLength : String which contains the minimum password length for 
	  		     *users and roles belonging to this organization
				 * public void setPasswordLength(String pwLength)
				 * @param pwExpirationDays : The number of days after which the password for 
	  			 * or users and roles  of the organization will expire if it is 
	  			 * not changed.
				 */
				authInfo.setPasswordLength("4");
				/*
				 * public void setPasswordExpDays(String pwExpirationDays){
				 */
				authInfo.setPasswordExpDays("4");
				/*
				 *  sets the <code>Authentication</code> object.
				 * <code>Authentication</code> object keeps the data of 
				 * <AUTHINFO> tag attributes and data of inner tag <AUTHENTICATION>.
				 * @param authentication -object of <code>Authentication</code> class 
				 * public void setAuthenticationObj(Authentication authentication)
				 */
			    modOrg.setAuthenticationObj(authInfo);
			   
				//This Modifies an Organization at the Report Engine 
			    //Syntax public void modifyOrganization(OrgInfo orgInfo,UserInfo userInfo)
                //                                    throws ISecurityException
				//@param orgInfo - : The Organization details
                //@param requestorUserInfo - : The current user 
				sMgr.modifyOrganization(modOrg,requesterUserInfo);
					
					
				}
				catch(ISecurityException ise)
				{
					System.out.println("The Organization with the given details was not found");
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}		
	} // End of main function
	
}	
	
	