/*
 * This Java API is used to Delete an existing report from the Intellicus Repository.
 * This would require user to provide UserInfo to authorize for performing Reports related activities.
 * User need to provide :
 * ReportID(Mandatory) - ReportId of the Report that is to be Deleted.
 */
 

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


import com.intellica.client.common.UserInfo;
import com.intellica.client.exception.LayoutHandlerException;
import com.intellica.client.init.ReportClient;
import com.intellica.client.layout.LayoutManager;

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;
/**
 * 
 * This class is used to delete an existing report from the Reporsitory. 
 * given Report ID which is to be deleted. 
 */
public class DeleteReport 
{
	public static void main(String arg[])
	{
			try{
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
				
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application.
				// Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
	            // @param userId   - : Id of the User Logged-In.
	            // @param password - : Password of the User Logged-In.
	            // @param orgId    - : Organization Id from which User Logged-In.
				String	userId	=	"Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo userInfo =	new UserInfo(userId,password,organization);
				
				//ReportId of the Report that is to be Deleted
				String reportId = "Annual Sales Figure Comparision";
							
				// Create a Layout Manager class object 
				// for report layout management related operations			
				LayoutManager lm= new LayoutManager();
	
	    		try{
	    			// Method to delete the report
	    			lm.deleteReportLayoutRow(reportId, userInfo);
	    			
	    		}catch(LayoutHandlerException e)
	    		{
	    			e.printStackTrace();
	    		}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}		
}		
		
		
		
		
		
		
	
    
	

