//This Java API is used to obtain the detalis of the Report with given Report ID.
//User need to provide the ReportID whose details is to be obtained.
//This would require user to provide UserInfo to authorize for Reports related Activites.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

import com.intellica.client.common.UserInfo;// user info bean 
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             //in initializing the report Engine interface (REInterface). 
import com.intellica.client.exception.LayoutHandlerException;//This Exception class is used for all Layout use cases.
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;//For all report layout operations client creates the object of this class.
import com.intellica.client.reportutils.Report;//This class contains details of irl file.

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;
/**
 * 
 * This class  is used to obtain the detalis of the Report, when Report ID is given.  
 * Method used for this purpose returns an object of Report class obtained from the report server
 */
public class GetReportDetails {
	
	public static void main(String args[])
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
						
									
			//Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			// Report class contains the details of the irl file. 
			// This is the default constructor to create report object.
			Report reportDetail=new Report();
			
			// ReportID whose Report Details are required
			String reportId = "32EC5F8B-71BE-DAEC-3CD4-897C57ACB0D9";
			
			//@param 1 : reportId - The report id whoes details are to be obtained.
			//@param 2 : userInfo - UserInfo for authorization. 
			reportDetail=lm.getReportDetails(reportId,requestorUserInfo);
			
			
			// Get the Deatils of the Report
			System.out.println("Category Name of Report : "+reportDetail.getCategoryMenuName());
			System.out.println("Report Name : "+reportDetail.getReportName());
			System.out.println("Date of Creation : "+reportDetail.getRepositDate());
			System.out.println("Priority of Report : "+reportDetail.getPriority());
			System.out.println("Category Name of Report : "+reportDetail.getCategoryMenuName());
			System.out.println("Description of Report : "+reportDetail.getDescription());
			System.out.println("Deployment Type of Report : "+reportDetail.getDeploymentType());
			System.out.println("Design Mode of Report : "+reportDetail.getDesignMode());
			
			
			
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(LayoutHandlerException lhe)
		{
			System.out.println("Failed to retrieve the report layout list for category");
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}

}
