/* This Program Adds column ti the Intellicus Repository and also fetch data feature.
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
import com.intellica.client.common.UserInfo;// user info bean. 
import com.impetus.intera.reportobjects.*;//This class is to manipulate the report objects.
import com.intellica.client.exception.BaseException;// This class is the base class of all the application generated exceptions engine may throw.
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             //in initializing the report Engine interface (REInterface). 
import com.impetus.intera.layout.sqleditor.SQLEditor;//This class contains properties and parsing logic for the SQLEDITOR of the report. 
import com.intellica.client.common.Enums;// Has Enums for the constants used
import com.intellica.client.init.ReportClient;//The purpose of this class to initialize the ConfigManager object. 
import com.intellica.client.common.Filter;//This class hold information about Filter applied in Adhoc Report Layout.

import com.intellica.client.layout.LayoutManager;//For all report layout operations client creates the object of this class
import com.intellica.client.exception.InvalidResponseException;
import com.intellica.client.utils.HashContainer;//This is a utility class which stores the value with a key.It is never case sensitive
import java.util.*;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This Class adds column to the Intellicus Repository and fetches data into it.For this it is
//required to provide the SQL source.
public class AddColumnWithFetchData{
	
	public static void main(String args[]) throws Exception{
		QOUseCase();
	}
	
	public static void QOUseCase() throws Exception{
		try{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);

			// SUPER ADMIN
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
		    
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			String qoName = "QO334";			
			
			QueryObject qoObj = (QueryObject)reportObjectManager.getReportObjectByName(Enums.IRO.TYPE.QUERY,qoName,requestorUserInfo);
		
			//The class contain all the information relate COLUMN Tag of Query Object 
			QueryObjectColumn  qoc = qoObj.getColumn("ACCOUNT_OWNER_NAME");
			qoc.setToFetchData(true);
			FetchData fetchData = new FetchData();
			
			SourceSQL srcSQL = new SourceSQL();
			
			SQLEditor sqlEditor = new SQLEditor();
			sqlEditor.setSQL("select ACCOUNTS.* from ACCOUNTS");
			srcSQL.setSqlEditor(sqlEditor);
			srcSQL.setDisplayColumn("ACCOUNT_OWNER_NAME");
			fetchData.setFetchDataSrc("SOURCESQL");
			fetchData.setSrcSQL(srcSQL);
			
			qoc.setFetchData(fetchData);
			//save the query object in intellicus 
			String status = "";
			reportObjectManager.replaceReportObject(qoObj,requestorUserInfo);
			
			//if the status string contains error 
			if(status.toLowerCase().indexOf("error")!=-1){
				System.out.println ("operation status "+status);
				//throw an excpetion if required
			}
			
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(Exception e){
			e.printStackTrace();
		}		
	}
	public static void filerUseCase() throws Exception{	
		try{
			//initialize report client 
			ReportClient.init();	
			LayoutManager lm = new LayoutManager();
			// SUPER ADMIN
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		   
			UserInfo userInfo = new UserInfo(userId,password ,organization);
			Filter f = new Filter();	
			f.setFilterField(Enums.Filters.SavedReportList.ISPUBLIC,null);
			f.setFilterField(Enums.Filters.SavedReportList.CATID,"99818F82-0161-BCEC-314E-730DCFB1B606");
			f.setFilterField(Enums.Filters.SavedReportList.REPORTID,null);
			f.setFilterField(Enums.Filters.SavedReportList.ORGID,organization);
			f.setFilterField(Enums.Filters.SavedReportList.USERID,"normaluser");
			
			Vector vectorSavedReport = lm.getSavedReportList(f,userInfo);
			Iterator itr = vectorSavedReport.iterator();
			com.intellica.client.reportutils.SavedReport svdReport = null;
			while(itr.hasNext())
				svdReport = (com.intellica.client.reportutils.SavedReport)itr.next();
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}	
}