/* This sample code is to add a new parameter Object in the Intellicus repository.
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/



import com.intellica.client.common.UserInfo; // user info bean 
import com.impetus.intera.reportobjects.ParameterObject;
import com.impetus.intera.reportobjects.ReportObjectException;
import com.impetus.intera.reportobjects.ReportObjectManager;//This class is used for Report Object related operations.
import com.impetus.intera.reportobjects.ReportObject;//This class is super class of all the report objects 
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
import com.intellica.client.reportutils.InputParam;
                                                              //in initializing the report Engine interface (REInterface). 
import com.intellica.client.common.Enums;// Has Enums for the constants used

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

public class AddPOToRoot
{
	public static void main(String args[]){ 
		try{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is);
			
		     // Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			
			//This class contains method to get/replace/add/delete a parameter object(QO)
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			//To create the Object of Report Object class.
			//public static ReportObject createReportObject(java.lang.String roType)
			ParameterObject poObj =(ParameterObject)ReportObject.createReportObject(Enums.IRO.TYPE.PARAMETER);
		    //This will be used as Name of the Parameter Object. 	
	    	String poName = "testparamObject";
	    	String poId = "testparamObjectID";
	    	//To set the name of the parameter Object.	
	    	poObj.setName(poName);
	    	 //To set the ID for parameter Object
	    	poObj.setId(poId);
	    	InputParam inputParam =new InputParam();
	    	inputParam.setName(poName);
	    	poObj.setInputParam(inputParam);
	    	reportObjectManager.addReportObject(poObj,requestorUserInfo);
     					
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(ReportObjectException roe){
			System.out.println("Error Message:"+roe.getErrorMessage());
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}//End of the main.	
}