/* This sample code is to delete the existing Query Object in the Intellicus repository.
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/


import com.intellica.client.common.UserInfo;// user info bean 
import com.impetus.intera.reportobjects.ReportObjectException;
import com.impetus.intera.reportobjects.ReportObjectManager;//This class is used for Report Object related operations.
import com.impetus.intera.reportobjects.QueryObject;// This class contains all the details about the query object.
import com.intellica.client.exception.BaseException;// This class is the base class of all the application generated exceptions engine may throw.
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             //in initializing the report Engine interface (REInterface). 
import com.intellica.client.common.Enums;// Has Enums for the constants used

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

public class DeleteReportObject{
	public static void main(String args[]){
		
		try{
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
					
			//This class contains method to get/replace/add/delete a Query object(QO)
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			//This will take the name of Query Object that is to be deleted.
			String qoName = "newqo1";
						
			//This is to Get java object of query object.
		    //getReportObjectByName method returns report object type object and you would require
		    // to type cast this object with java objet of Query Object class.
			QueryObject qoObj=(QueryObject)reportObjectManager.getReportObjectByName(Enums.IRO.TYPE.QUERY,qoName,requestorUserInfo);
			
			//This will be used to Delete the Query Object.
			//deleteReportObject(com.impetus.intera.reportobjects.ReportObject reportObject,
            //                   com.intellica.client.common.UserInfo userInfo)
			reportObjectManager.deleteReportObject(qoObj,requestorUserInfo);
					
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(ReportObjectException roe){
			System.out.println("Error Message:"+roe.getErrorMessage());
			
		}
		catch(Exception e){
			
			e.printStackTrace();			
		}
	}//End of the main.	
} 