//This Java API is used to save the Report Obeject i.e. Parameter Object or Query Object in the Intellicus Repository
//This would require user to provide UserInfo to authorize for Reports related Activites.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs



 //This class saves the report objects: parameter objects and the query objects


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 **/

 

import com.intellica.client.common.UserInfo; // user info bean 
import com.impetus.intera.reportobjects.QueryObjectColumn;
import com.impetus.intera.reportobjects.ReportObjectException;
import com.impetus.intera.reportobjects.ReportObjectManager;//This class is used for Report Object related operations.
import com.impetus.intera.reportobjects.ReportObject;//This class is super class of all the report objects 
import com.impetus.intera.reportobjects.QueryObject;// This class contains all the details about the query object.
import com.impetus.intera.layout.sqleditor.SQLEditor;//This class contains properties and parsing logic for the SQLEDITOR of the report. 
import com.intellica.client.common.Enums;// Has Enums for the constants used
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
//in initializing the report Engine interface (REInterface). 
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.lang.String;
import java.util.ArrayList;

/*
 * This class is used to create a Report Object and save it in the Intellicus Repository
 */
public class SaveReportObject
{
	public static void main(String args[]){
		
		try{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			
			com.intellica.client.init.ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
						     
			
			//This class contains method to get/replace/add/delete a Query object(QO)
			//It is also used for Report Object related operations. It acts as the manager for all the classes in this package. 
			ReportObjectManager reportObjectManager = new ReportObjectManager();
			
			
			//ArrayList reportObjList=new ArrayList();
	         
		    System.out.println("What report objects you want to Save?");
		    System.out.println("Choose 1 for parameter objects :");
		    System.out.println("Choose 2 for query objects :");
			   
		    BufferedReader br=new BufferedReader (new InputStreamReader(System.in));//Reading the user choice
		    int choice=Integer.parseInt(br.readLine());//the choice of the user
		       
		    //If User want to save the Parameter Object            
		    if(choice==1)
		    {	  
			    ReportObject repObjectPrm=ReportObject.createReportObject(Enums.IRO.TYPE.PARAMETER);
			    //reportObjList=reportObjectManager.getReportObjectList(repObjectPrm.getType(),userInfo);	
		          
			    String prmObject="newPrmObject1";
			    repObjectPrm.setName(prmObject);
			    
			    //Method used to save the Report Object in the Repository
			    reportObjectManager.saveReportObjects(prmObject,requestorUserInfo);
			   	  
		    }
		    
		    //If User want to save the Query Object       
		    else if(choice==2)
		    {
		        QueryObject repObjectQuery=(QueryObject)ReportObject.createReportObject(Enums.IRO.TYPE.QUERY);
				// reportObjList=reportObjectManager.getReportObjectList(repObjectQuery.getType(),userInfo); 
				   	 
				String qOName="newQObject1";
				repObjectQuery.setName(qOName);
				   	 				   	
				repObjectQuery.setConnectionType("Default");
				// If Connection Type is Named then To set the Connection name for the Querry Object.
				// qoObj.setConnectionName("Oracle");
				// Create the SQLEditor Object.
				SQLEditor sqlEditor = repObjectQuery.getSqlEditor();
				// To set the SQL for fields in Query Object.
				sqlEditor.setSQL("select JOB,ENAME,SAL from EMP",true);	
				// To add the columns in Query Object.
				// QueryObjectColumn(java.lang.String columnName,
				//                   java.lang.String caption,
				//                   java.lang.String width,
				//                   java.lang.String dataType)
				QueryObjectColumn qoc1 = new QueryObjectColumn("JOB","JOB","10","");
				QueryObjectColumn qoc2 = new QueryObjectColumn("ENAME","EMPLOYEE NAME","10","");
				QueryObjectColumn qoc3 = new QueryObjectColumn("SAL","SALARY","10","");
				// To make an Array of the columns.
				ArrayList ArrColumn=new ArrayList();
				ArrColumn.add(qoc1);
				ArrColumn.add(qoc2);	
				ArrColumn.add(qoc3);
				// To set the columns in the Query Object.
				repObjectQuery.setColumnDetails(ArrColumn);
				   		
				// This will save the query objects	 
				reportObjectManager.saveReportObjects(qOName,requestorUserInfo);
				   	 
			}
		        
				
			  
	 			
		    }//end try
			catch(InterfaceInitException iie)
			{
				System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
				//	iie.printStackTrace();
			}
			catch(ReportObjectException roe){
				System.out.println("Error Message:"+roe.getExtMessage());
			}
			catch(IOException ioe){
				System.out.println("Error Message:"+ioe.getMessage());
			}
			catch(Exception e)
			{
				e.printStackTrace();
				
			}
		}
	}		