//This Java API is used to get IP Address and Port of the Report Engine.


//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
															 // in initializing the report Engine interface (REInterface). 
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.client.layout.LayoutManager;// for report layout management related operations

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

/**
 * 
 * This class is used to get Report Engine's IP Address and Port number, i.e. set through any of the constructor or if not then returns the default value from ConfigManager class.
 * Method used to implement this returns String value.
 */
public class GetReportEnginePortAndIP {
	
	public static void main(String args[])
	{
		
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
									
			// Create a Layout Manager class object 
			// for report layout management related operations			
			LayoutManager lm = new LayoutManager();
			
			// method used to get the IP Address of Report Engine 
			// Returns ReportEngine IP as a String value.
			String reportEngineIP=lm.getReportEngineIP();
					
			// method used to get the Port of Report Engine 
			// Returns report Engine Port as Integer value
			int reportEnginePort=lm.getReportEnginePort();
			
			System.out.println("IP Address Of the ReportEngine : "+reportEngineIP);
			System.out.println("Port Of the Report Engine : "+reportEnginePort);
				
		}
		catch(InterfaceInitException iie)
		{
		System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		//	iie.printStackTrace();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	
	}
}
