
/* This program 
 * 1) Creates a userinfo Object of current logged in User.
 * 2) Returns SMTP Server Value
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

// Import Section
// Use intellica jar to import these classes
import com.intellica.client.common.UserInfo; // user info bean 
import com.intellica.client.exception.ClientException;//This class is used to create 
                                                      //generalized exception which may occure at
                                                      //any application level.It is not bounded with any use case. 
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
                                                         //or if read or write operation cant be performed from or to the engine
                                                         //or If some error has occured while executing the request on the engine.
                                                         //or If the response xml obtained from server cannot be parsed 
import com.intellica.client.init.ReportClient; // Has Init Method
import java.util.ArrayList; // Array list
import com.intellica.client.security.SecurityManager;// This is the controller class for all 
                                                     //Administration related operations

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

// This  class Creates a userinfo Object of current logged in User and Returns SMTP Server Value

public class  GetReportServerProperty
{
		public static void main(String str[]){
		try{
			
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			 // Create a SecurityManager class object 
			 // for getting the controller information for all Administration related operations
			  SecurityManager sMgr=SecurityManager.getInstance();

             // This will return array list  of values of Reporrt Server properties.
			  ArrayList arrList =sMgr.getReportServerPropDetails(requestorUserInfo);
             
             //Set the key for the server property.This key is the name of the property as specified in the
             // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
             String key="SMTP_SERVER";// For getting value for Report Server property.
             
             //This will return value for the SMTP_SERVER specified as key.
              String value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 			  System.out.println ("SMTP_SERVER Value : "+value);
 			  
 			  key="LISTENER_PORT";
             
              //This will return value for the LISTENER_PORT specified as key.
              value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 			  System.out.println (" LISTENER_PORT Value : "+value);
 			  
 			 key="DATABASE_CONNECTION_TIMEOUT";
 	             
 	         //This will return value for the DATABASE_CONNECTION_TIMEOUT specified as key.
 	         value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	 		 System.out.println ("DATABASE_CONNECTION_TIMEOUT Value : "+value);
 	 			  
 	 		key="SECURITY_FEATURES";
 	 	             
 	        //This will return value for the SECURITY_FEATURES specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("SECURITY_FEATURES Value : "+value);
 	  		
 	  		key ="AUDIT_LOG";
 	  		
 	        //This will return value for the AUDIT_LOG specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("AUDIT_LOG Value : "+value);
 	  		
 	  		key = "QUEUE_SIZE";
 	        //This will return value for the QUEUE_SIZE specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("QUEUE_SIZE Value : "+value);

 	  		
 	  		key = "PAGE_CHUNKSIZE";
 	        //This will return value for the PAGE_CHUNKSIZE specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("PAGE_CHUNKSIZE Value : "+value);

 	  		key = "LOG_LEVEL";
 	        //This will return value for the LOG_LEVEL specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("LOG_LEVEL Value : "+value);

 	  		key = "OUTPUT_DIRECTORY";
 	        //This will return value for the OUTPUT_DIRECTORY specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("OUTPUT_DIRECTORY Value : "+value);
 	  		

 	  		key = "XML_DATA_SOURCE_DIRECTORY";
 	        //This will return value for the XML_DATA_SOURCE_DIRECTORY specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("XML_DATA_SOURCE_DIRECTORY Value : "+value);

 	  		key = "TEMP";
 	        //This will return value for the TEMP specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("TEMP Value : "+value);

 	  		key = "LOG";
 	        //This will return value for the LOG specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("LOG Value : "+value);

 	  		key = "USER_THREADS";
 	        //This will return value for the USER_THREADS specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("USER_THREADS Value : "+value);

 	  		key = "CANCEL_THREADS";
 	        //This will return value for the CANCEL_THREADS specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CANCEL_THREADS Value : "+value);

 	  		key = "SERVICE_THREADS";
 	        //This will return value for the SERVICE_THREADS specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("SERVICE_THREADS Value : "+value);

 	  		key = "FONT_DIRECTORY";
 	        //This will return value for the FONT_DIRECTORY specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("FONT_DIRECTORY Value : "+value);

 	  		key = "LEFT_MARGIN_OFFSET";
 	        //This will return value for the LEFT_MARGIN_OFFSET specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("LEFT_MARGIN_OFFSET Value : "+value);

 	  		key = "TOP_MARGIN_OFFSET";
 	        //This will return value for the TOP_MARGIN_OFFSET specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("TOP_MARGIN_OFFSET Value : "+value);

 	  		key = "SCALE_OFFSET";
 	        //This will return value for the SCALE_OFFSET specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("SCALE_OFFSET Value : "+value);

 	  		key = "CLIENT_SESSION_TIMEOUT";
 	        //This will return value for the CLIENT_SESSION_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CLIENT_SESSION_TIMEOUT Value : "+value);

 	  		key = "REMOTE_SESSION_TIMEOUT";
 	        //This will return value for the REMOTE_SESSION_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("REMOTE_SESSION_TIMEOUT Value : "+value);

 	  		key = "RTF_FIELD_CONTROL_MAP";
 	        //This will return value for the RTF_FIELD_CONTROL_MAP specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("RTF_FIELD_CONTROL_MAP Value : "+value);

 	  		key = "DATA_SOURCE_FETCH_SIZE";
 	        //This will return value for the DATA_SOURCE_FETCH_SIZE specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("DATA_SOURCE_FETCH_SIZE Value : "+value);

 	  		
 	  		key = "CSA_TIMEOUT";
 	        //This will return value for the CSA_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CSA_TIMEOUT Value : "+value);

 	  		key = "CACHE_PATH";
 	        //This will return value for the CACHE_PATH specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CACHE_PATH Value : "+value);

 	  		key = "AUDITLOG_PURGE_TIME";
 	        //This will return value for the AUDITLOG_PURGE_TIME specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("AUDITLOG_PURGE_TIME Value : "+value);

 	  		key = "CACHE_PURGE_TIME";
 	        //This will return value for the CACHE_PURGE_TIME specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CACHE_PURGE_TIME Value : "+value);


 	  		key = "AUTHORIZATION_CACHE_TIMEOUT";
 	        //This will return value for the AUTHORIZATION_CACHE_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("AUTHORIZATION_CACHE_TIMEOUT Value : "+value);

 	  		key = "REPOSITORY_CACHE_TIMEOUT";
 	        //This will return value for the REPOSITORY_CACHE_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("REPOSITORY_CACHE_TIMEOUT Value : "+value);

 	  		key = "REPOSITORY_CACHE_TIMEOUT";
 	        //This will return value for the REPOSITORY_CACHE_TIMEOUT specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("REPOSITORY_CACHE_TIMEOUT Value : "+value);

 	  		key = "SORT_AREA_SIZE";
 	        //This will return value for the SORT_AREA_SIZE specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("SORT_AREA_SIZE Value : "+value);

 	  		key = "FILE_DATA_SOURCE_PATH";
 	        //This will return value for the server property specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("FILE_DATA_SOURCE_PATH Value : "+value);

 	  		key = "DATA_CACHING";
 	        //This will return value for the FILE_DATA_SOURCE_PATH specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("DATA_CACHING Value : "+value);

 	  		key = "CACHE_FILES_COMPRESSION";
 	        //This will return value for the CACHE_FILES_COMPRESSION specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("CACHE_FILES_COMPRESSION Value : "+value);

 	  		
 	  		key = "SCHD_JOB_DISPATCH_QUEUE_SIZE";
 	        //This will return value for the SCHD_JOB_DISPATCH_QUEUE_SIZE specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("SCHD_JOB_DISPATCH_QUEUE_SIZE Value : "+value);

 	  		key = "HELPER_EXEC_THREADS";
 	        //This will return value for the HELPER_EXEC_THREADS specified as key.
 	        value=sMgr.getReportServerPropValue(arrList ,key, requestorUserInfo);
 	  		System.out.println ("HELPER_EXEC_THREADS Value : "+value);

 	  		 	  		
		    }
			catch(ClientException ce)
			{
		    	System.out.println("Unable to get the value from report server");
		    }
		   catch(ISecurityException ise)
			{
	           System.out.println("The Organization with the given details was not found");
			}
		    catch(Exception e)
			{
				e.printStackTrace();
		    }
	}
}
