
/* This program 
 * 1) Creates a userinfo Object of current logged in User.
 * 2) Set SMTP Server Value
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

// Import Section
// Use intellica jar to import these classes
import com.intellica.client.common.UserInfo; // user info bean 
import com.intellica.client.exception.ISecurityException;//This exception occurs if connection can't be established with the engine 
														 //or if read or write operation cant be performed from or to the engine
														 //or If some error has occured while executing the request on the engine.
														 //or If the response xml obtained from server cannot be parsed 
import com.intellica.client.init.ReportClient; // Has Init Method
import java.util.ArrayList; // Array list
import com.intellica.client.security.SecurityManager;// This is the controller class for all Administration related operations
import java.util.HashMap;//A HashMap lets you look up values by exact key (always case-sensitive). 
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class  Creates a userinfo Object of current logged in User and Set SMTP Server Value
public class  SetReportServerProperty
{
		public static void main(String str[]){
		try{
			
			
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
		
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
		    UserInfo requestorUserInfo	=	new UserInfo(userId,password,organization);
			
			 // Create a SecurityManager class object 
			 // for getting the controller information for all Administration related operations
			  SecurityManager sMgr=SecurityManager.getInstance();

			  HashMap ServerPropHMap= new HashMap();
			  
			  String key="SMTP_SERVER";
			  String value="192.168.100.20";
			  // Set the key for the server property, SMTP_SERVER.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);
              
			  key="DATABASE_CONNECTION_TIMEOUT";
			  value="800";
			  // Set the key for the server property, DATABASE_CONNECTION_TIMEOUT.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);
			  
			  key="SECURITY_FEATURES";
			  value="enabled";
			  // Set the key for the server property, SECURITY_FEATURES.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);
			  
			  key="QUEUE_SIZE";
			  value="900";
			  // Set the key for the server property, QUEUE_SIZE.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="LOG";
			  value="../logs";
			  // Set the key for the server property, LOG.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="PAGE_CHUNKSIZE";
			  value="10";
			  // Set the key for the server property, PAGE_CHUNKSIZE.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="LOG_LEVEL";
			  value="INFO";
			  // Set the key for the server property, LOG_LEVEL.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="USER_THREADS";
			  value="5";
			  // Set the key for the server property, USER_THREADS.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="SERVICE_THREADS";
			  value="5";
			  // Set the key for the server property, SERVICE_THREADS.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="CLIENT_SESSION_TIMEOUT";
			  value="600";
			  // Set the key for the server property, CLIENT_SESSION_TIMEOUT.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="AUDITLOG_PURGE_TIME";
			  value="30";
			  // Set the key for the server property, AUDITLOG_PURGE_TIME.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="WITHHOLD_PURGE_TILL_ARCHIVE";
			  value="disable";
			  // Set the key for the server property, WITHHOLD_PURGE_TILL_ARCHIVE.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="REPOSITORY_CACHE_TIMEOUT";
			  value="15";
			  // Set the key for the server property, REPOSITORY_CACHE_TIMEOUT.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  key="EXIT_ON_ERROR";
			  value="disable";
			  // Set the key for the server property, EXIT_ON_ERROR.This key is the name of the property as specified in the
              // ReportEngine.properties at <install_dir>\ReportEngine\Config folder. 
			  ServerPropHMap.put(key,value);

			  //public java.lang.String saveReportServerProperties(java.util.HashMap reportServerPropMap,
	          //                                            UserInfo userInfo)throws ISecurityException
			  //@param: reportServerPropMap - : HashMap which keeps the property name as key and its its concerning value as the value.
			  //@param: userInfo            - : The UserInfo object 

 			  sMgr.saveReportServerProperties(ServerPropHMap,requestorUserInfo);
 			  
    
		    } 
			catch(ISecurityException ise)
			{
	           System.out.println("Unable to save the Report server property details");
			}		  
		    catch(Exception e)
			{
				e.printStackTrace();
		    }
	}
}
