//This Java API is used to add a new role in the existing Organization.
//The User need to provide the Role ID i.e. to be added and the Organization ID of the existing Organization in 
//which the Role is to be added.
//This would require user to provide UserInfo to authorize for Roles related Activities.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/

// Import Section
// Use intellica jar to import these classes
import com.intellica.client.init.ReportClient; // Has Init Method
import com.intellica.client.common.UserInfo; // Object used to pass in run report
import com.intellica.client.security.SecurityManager;//Controller class for all security related operations  
import com.intellica.client.security.RoleInfo; // Has information about a role in the application
import com.intellica.client.exception.ISecurityException;// Exception class for all security related operations.
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
                                                             // in initializing the report Engine interface (REInterface).import com.intellica.client.init.ReportClient; // Has Init Method
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

/*
 *This class is used to Add a Role in to the Intellicus Repository
 */
public class AddRole
{

	public static void main(String args[])
	{
		
		try
		{
						
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
									
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as Add role etc.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo 	 requestorUserInfo	=	new UserInfo(userId,password,organization);

			
			String roleId	="Manager";// Id of the role to be added 
			String orgId	="Organization1";// Id of the organization in which role to be added
			
			// Create a Security controller class object using its factory 
			// for user/role management related operations
			SecurityManager sMgr=SecurityManager.getInstance();
			
			//Stores the information about a role in the application.
			//A role can have certain preveleges such as it can have Admin rights,Access Rights for reports or category. 
			//A user in the application can have 0 or more roles,and takes various preveleges from the roles. 
			RoleInfo roleInfo=new RoleInfo(roleId,orgId);		
				//	Method to add a new role 
				//  Syntax : addRole (role to be added , requestor admin user)
				sMgr.addRole(roleInfo,requestorUserInfo);
			}	
		    catch(InterfaceInitException iie)
		    {
		        System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
		        //	iie.printStackTrace();
		    }
			catch(ISecurityException e)
			{
				// Rootcause of the SecurityException sent by the report server
				System.out.println ("Error from Server:"+e.getExtMessage());
				
			}
											
		catch(Exception e)
		{
			e.printStackTrace();
		}
	} // End of main function
}		
 