//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

// Import Section
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

// Use intellica jar to import these classes
import com.intellica.client.common.Enums;
import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.schd.client.Schedule;
import com.intellica.schd.client.SchedulerManager;

//This class will create schedule to be executed daily.
public class CreateNewSchedule {
	public static void main(String args[]){
		try{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			//Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			UserInfo userInfo	=	new UserInfo("Admin","Admin","Intellica");
			// Create a Scheduler Manager class object 
			// for scheduler management related operations
			SchedulerManager schdMgr	=	new SchedulerManager();
			/* This is to add a new schedule
			  This object holds an instance of Schedule class.  
			  This Schedule is used by the ScheduledJob
			  
			*/ 	
			//create new instance of schedule. This constructor call takes care
			//of initializing schedule Id as well.			
			Schedule schedule	=	new Schedule();
//			 Set the schedule name, This line may not require 
			schedule.setScheduleName("testSchedule");
			schedule.setScheduleID("testSchedule");
			
			//Set Frequency type as Daily
			//Other values for Freequency Type could be 
			//	Enums.Schedule.FrequencyTypes.DAILY
			//	Enums.Schedule.FrequencyTypes.MONTHLY
			//	Enums.Schedule.FrequencyTypes.WEEKLY
			schedule.setFrequencyType(Enums.Schedule.FrequencyTypes.DAILY);
			
			//The schedule starts on this date 
			schedule.setStartDate("01/07/2009");
			
			//The schedule ends on this date (Set it blank for schedule to repeat infinitely)
			schedule.setEndDate("01/08/2010");
			
			//Set time type as ONCE
			//Other values for Time Type could be :
			//	Enums.Schedule.TimeTypes.ONCE
			//	Enums.Schedule.TimeTypes.REPEAT
			schedule.setTimeType(Enums.Schedule.TimeTypes.ONCE);
			
			//Execution Time for the Schedule to run the task
			String executionTime = "12:57:10";
			//Set execution time on the scheduled day in HH:Mi:SS format
			schedule.setOnceTime(executionTime);
			
			//To share the Schedule
			//	true : allowing more than one task to share the this schedule
			//	false : For dedicated Shedules in which this schedule can only be associated with 
			// 			only one Schedule.			
			schedule.setIsShared(true);
			schdMgr.addSchedule(schedule, userInfo);
		}catch(Exception e){}
	}
}
