//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
 
 

// Import Section
// Use intellica jar to import these classes

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

import com.intellica.client.common.Enums;
import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error in initializing the report Engine interface (REInterface).
import com.intellica.client.exception.SchedulerException;
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.schd.client.SchedulerManager;

public class  GetHistory
{
		public static void main(String str[]){
		try{
			
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
							
				// Create a Scheduler Manager class object 
				// for scheduler management related operations
				SchedulerManager schdMgr	=	new SchedulerManager();
													
				//-----------------------------------------------------
			
				//Job ID for which history is to be obtained
				String jobID = "JobD6D41A62-2DA4-C874-C151-CB9666AF573F";
												
				//-----------------------------------------------------
				
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application.
				//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
		        //@param userId   - : Id of the User Logged-In.
		        //@param password - : Password of the User Logged-In.
		        //@param orgId    - : Organization Id from which User Logged-In.
				String	userId	=	"Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo userInfo =	new UserInfo(userId,password,organization);
				//setFilterInformation('<%=maxRow%>','<%=userId%>','<%=orgId%>','<%=ownerPublic%>','<%=ownerPrivate%>','<%=fromDate%>','<%=toDate%>','<%=jobId%>', '<%=status%>','<%=jobType%>','<%=frequency%>','<%=jobRunTime%>');

				//Filters																									
				String filters[][] = new String[2][2];
				filters[0][0] = "JOBID";
				filters[0][1] = jobID;	
				filters[1][0] = Enums.Filters.JobExecutionStatus.ORGID;
				filters[1][1] = "Intellica";	
				
				
				//Returns the scheduleJobHistory in ArrayList containing HashMap as each element for 
				//each row. The HashMap contains the details required for showing the list like the 
				//HISTORYID, JOBID, JOBNAME etc. as name value pair. 
				//Syntax : public java.util.ArrayList getScheduledJobHistory(java.lang.String[][] filters,
                //													        UserInfo userInfo)
                //@param filters - Multi-dim String Array contains the[0] element as NAME & [1] as VALUE attributes value.
				//@param userInfo - The userInfo object for authorization. 
				ArrayList list = schdMgr.getScheduledJobHistory(filters , userInfo);
				
				//Print History
				System.out.println ("Number of Reports run by Job:"+list.size());
				System.out.println ("Jobs"+list);
				
				
				HashMap map,mapDetail;
				Iterator itr=list.iterator();
				ArrayList completeList=new ArrayList();
				
				while(itr.hasNext())
				{
					map=new HashMap();
					map=(HashMap)itr.next();
					
					String sts=(String)map.get("STATUS");
					String historyId=(String)map.get("HISTORYID");
					System.out.println("historyId-->"+historyId);
					String filters1[][] = new String[1][2];
					filters1[0][0] = "HISTORYID";
					filters1[0][1] = historyId;
					ArrayList detailList = schdMgr.getScheduledJobHistoryDetail(filters1, userInfo);
					String description="";
					Iterator itrDetail=detailList.iterator();
					//System.out.println("detailList.size()-->"+detailList.size());
					//System.out.println ("Job Details"+detailList);
					while(itrDetail.hasNext())
					{
						mapDetail=new HashMap();
						mapDetail=(HashMap)itrDetail.next();
						 description=(String)mapDetail.get("DESCRIPTION");
						 break;
					}
					
					//System.out.println("JOBID-->"+jobID+"  sts-->"+sts+"  DESCRIPTION-->"+description);
					String statusAndDetail="JOBID:"+jobID+"\t"+ "HISTORYID:"+historyId+"\t"+"sts:"+sts+"\t"+"DESCRIPTION:"+description;
					completeList.add(statusAndDetail);
				}
				
				for(int i=0;i<completeList.size();i++)
				{
					System.out.println((String)completeList.get(i));
				}
		}
		catch(InterfaceInitException iie)
		{
			iie.printStackTrace();
		}
		catch(SchedulerException se)
		{
			se.printStackTrace();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}


