//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
//This program 
//1) Creates a userinfo Object of current logged in User.
//2) Create a list to get the scheduled job history.
//3) Create a hashmap to get the details of each element in history list.
//4) Get the history id from hash map.
//5) Get the list of History detail on the basis of history id.
//6) Create a hashmap to get the description of status .
//
//Import Section
//Use intellica jar to import these classes
/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

import com.intellica.client.common.UserInfo;// user info bean
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error in initializing the report Engine interface (REInterface).
import com.intellica.client.exception.SchedulerException;
import com.intellica.client.init.ReportClient;// Has Init Method
import com.intellica.schd.client.SchedulerManager;

public class  GetHistoryAndDetail
{
		public static void main(String str[]){
		try{
			
			
				// Static Init call. it will read the properties for report server related attributes 
				// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
				//in the INTERA_HOME property of the ReportClient.properties file.
				InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																															//with the absolute path of ReportClient.properties.
				ReportClient.init(is);
				   
				
				// Create a Scheduler Manager class object 
				// for scheduler management related operations
				SchedulerManager schdMgr	=	new SchedulerManager();
													
				//-----------------------------------------------------
			
				/**********ArcSight created Job ID for which history is to be obtained******************/
				String jobID = "JobD6D41A62-2DA4-C874-C151-CB9666AF573F";
				
								
				//-----------------------------------------------------
				
				// Prepare a requestor user info bean object.
				// This user should be present in Intellicus application.
				//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
		        //@param userId   - : Id of the User Logged-In.
		        //@param password - : Password of the User Logged-In.
		        //@param orgId    - : Organization Id from which User Logged-In.
				String	userId	=	"Admin";
				String password = "Admin";
				String organization = "Intellica";
				UserInfo userInfo =	new UserInfo(userId,password,organization);
			
				//Filters																									
				String filters1[][] = new String[1][2];
				filters1[0][0] = "JOBID";
				filters1[0][1] = jobID;	
				
				
				//Get the history corresponding to jobId.
				ArrayList listForStatus = schdMgr.getScheduledJobHistory(filters1 , userInfo);
				
				HashMap mapForStatus,mapForStatusDetail;
				Iterator itrForStatus=listForStatus.iterator();
				ArrayList completeList=new ArrayList();
				
				while(itrForStatus.hasNext())
				{
					mapForStatus=new HashMap();
					mapForStatus=(HashMap)itrForStatus.next();
					
					String sts=(String)mapForStatus.get("STATUS");
					String historyId=(String)mapForStatus.get("HISTORYID");
					System.out.println("historyId..."+historyId);
					//Corresponding to HISTORYID,get the DESCRIPTION for detail message
					String filters2[][] = new String[1][2];
					filters2[0][0] = "HISTORYID";
					filters2[0][1] = historyId;
					
					ArrayList listForStatusDetail = schdMgr.getScheduledJobHistoryDetail(filters2, userInfo);
					String description="";
					Iterator itrForStatusDetail=listForStatusDetail.iterator();
					System.out.println("itrForStatusDetail.."+itrForStatusDetail);
					while(itrForStatusDetail.hasNext())
					{
						mapForStatusDetail=new HashMap();
						mapForStatusDetail=(HashMap)itrForStatusDetail.next();
						 description=(String)mapForStatusDetail.get("DESCRIPTION");
						 break;
					}
					String statusAndDetail="JOBID:"+jobID+"\t"+ "HISTORYID:"+historyId+"\t"+"STATUS:"+sts+"\t"+"DESCRIPTION:"+description;
					System.out.println("statusAndDetail..."+statusAndDetail);
					completeList.add(statusAndDetail);
				}
				
				//Print the JOBID,HISTORYID,STATUS,DESCRIPTION
				System.out.println("completeList.size.."+completeList.size());
				for(int i=0;i<completeList.size();i++)
				{
					System.out.println((String)completeList.get(i));
				}
		}
		catch(InterfaceInitException iie)
		{
			iie.printStackTrace();
		}
		catch(SchedulerException se)
		{
			se.printStackTrace();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}


