//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/
 
 
// This program does the following:
// 1) Initialize report client.
// 2) Creates UserInfo object.
// 3) Prepare a scheduler manager object
// 4) Get the task object for the specified task id
// 5) Get the hash map of input parameter from the task object
// 6) Get the input parameter names and their values set at the task creation time.
//
// Import Section
// Use intellica jar to import these classes

import com.intellica.client.common.UserInfo; // user info bean
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error in initializing the report Engine interface (REInterface).
import com.intellica.client.exception.SchedulerException;
import com.intellica.client.init.ReportClient; // Has Init Method
import com.intellica.schd.client.SchedulerManager;
import com.intellica.schd.client.Task;
import java.util.HashMap;//A HashMap lets you look up values by exact key (always case-sensitive).

import java.util.Set;
import java.util.Iterator;//Iterator takes the place of Enumeration in the Java collections framework
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

public class  GetTaskParameters{
	public static void main(String str[]){
		try{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax : public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
	        //@param userId   - : Id of the User Logged-In.
	        //@param password - : Password of the User Logged-In.
	        //@param orgId    - : Organization Id from which User Logged-In.
			String	userId	=	"Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo userInfo =	new UserInfo(userId,password,organization);
			
			//Prepare a scheduler manager object for scheduler related operations.
			SchedulerManager schdMgr=	new SchedulerManager();
			
			// Set the task id.
			String taskId	=	"1169627272589";
			
			// Get the task object for the specified task id.
			Task taskObj	=	schdMgr.getTask(taskId,userInfo);
			
			// Get the hash map of input parameter from the task object
			HashMap inputParamMap	=	taskObj.getInputParamMap();
			
		 	//Returns a set view of the keys contained in this input parameter hashmap
		 	Set mapKeys		=	inputParamMap.keySet();
		 	
		 	//Returns an iterator over the elements in this set
		 	Iterator	iter	=	mapKeys.iterator();
		 	
		 	//This will return the parameter value for the given parameter.
		 	String prmName	=null;
		 	String prmValue	=null;
		 	while(iter.hasNext()){
		 		
		 		// This will return the name of the parameter.
		 		prmName		=	(String)iter.next();
		 		
		 		// This will return parameter value.
		 		//For multi select parameters, values will be comma separated.
		 		prmValue	=	(String)inputParamMap.get(prmName);
		 		
		 		System.out.println ("Parameter Name:  "+prmName);
		 		System.out.println ("Parameter Value: "+prmValue);	
		 		
		 	}	
			
		}
		catch(InterfaceInitException iie)
		{
			iie.printStackTrace();
		}
		catch(SchedulerException se)
		{
			se.printStackTrace();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
