//This program gets the list of reports from the Intellicus repository ,schedules them and sends them as attachment through mail
//and if the reports fail the error messages go.
/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/
 // Import Section
// Use intellica jar to import these classes
import com.intellica.client.init.ReportClient; //This class is used to initialize the Intellica client SDK.
                                               //This initialize the ConfigManager object.
import com.intellica.client.common.Enums;//This class is having all the enums used in the InteraJ report engine.
import com.intellica.client.common.InteraConstants;//This class contains all the Constants used in Reporting System.
import com.intellica.client.common.UserInfo; //This class stores the login user information.Object used to pass in run report
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error in initializing the report Engine interface (REInterface).
import com.intellica.client.exception.SchedulerException;
import com.intellica.client.layout.LayoutManager;// for report layout management related operations			
import com.intellica.client.reportutils.Report;//Class contains the details of the irl file. 
import com.intellica.schd.client.EMailProperty;//This class holds the system parameters of EMail operation type. 
                                               //It acts as a data container for the operation type Email. The
                                               //default value for all the parameters is the empty string. 
import com.intellica.schd.client.ScheduleJob;//This class holds the Job specific details. It contains the Task 
                                             //and Schedule objects that can be used for scheduling a job.
import com.intellica.schd.client.Task;//This class is used to create a task using a given report
                                      //and assosciated system and user parameters. 
import com.intellica.schd.client.SchedulerManager;//This is the controller class for all operations related to
												  //scheduler. 
import com.intellica.client.reportutils.InputParam;//This class contains the detail of the Input parameter. 

import java.util.HashMap;//This class makes no guarantees as to the order of the map; in particular, 
                         //it does not guarantee that the order will remain constant over time. 

import java.util.Hashtable;//This class implements a hashtable that maps keys to values,any
                           //non null object can be used as a key or as a value
import java.util.Vector;//This class implements a growable array of objects.Like an array it 
                        //contains components that can be accessed using an integer index.
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class gets the list of reports from the Intellicus repository ,schedules them and sends them as attachment through mail
//and if the reports fail the error messages go.
public class ScheduleReportlist
{	
	public static void main(String args[])
	{
		try
		{
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.

			String userId = "Admin";
			String password = "Admin";
			String organization = "Intellica";
			UserInfo userInfo=new UserInfo(userId,password,organization);
			
			// when server running in security disabled mode
			//	UserInfo userInfo=UserInfo.getEmptyInstance();
			
			//Class is responsible for managing following type of request Report layout
			//For all report layout operations client creates the object of this class. 
			//The methods of this class are stateless and takes all required information such as requestor User Info etc. in each call.
			LayoutManager lm= new LayoutManager();//Default Constructor Creates the Layout Manager class object Layout manager initaializes
			//by reading configuration file (ReportClient.properties) for Report Server IP address and Port number (TCP Socket)
			
			
			//The class provides methods which acts as an interface for sending diffrent requests related to Scheduler to report 
            //engine from the jsps. This is a singleton class, whose instance can be obtained by using the getInstance method. 
			SchedulerManager schdMgr	=	new SchedulerManager();
			//Creates a vector that contains the list of reports retrieved from the Intellicus repository.
			Vector vecReportList= new Vector();
								
		    //This will return All Report List on Which user has AccessRights and all the pub.  
			vecReportList=lm.getReportList(userInfo);
           	    		
			if(vecReportList!=null)
			{
					for (int j = 0;j<vecReportList.size(); j++)
					{
							Report report = (Report)vecReportList.get(j);
							String reportId=report.getReportId();
							System.out.println ("");
				            //Displays the report name of the retrieved reports from the Intellicus repository
							System.out.println ("ReportName:"+report.getReportName());
                            //Displays the report id of the retrieved reports from the Intellicus repository
				            System.out.println ("ReportId:"+reportId);
                            //Displays the report description of the retrieved reports from the Intellicus repository
							System.out.println ("Description:"+report.getDescription());
							//Gives the status of the reports retrieved from the Intellicus repository whether the reports are private or public.
							System.out.println ("is public? "+report.getIsPublic());
											    
							//System.out.println ("parameters : "+report.getByteUPX());
							
							
							/* THIS IS TO ADD A NEW TASK
							   This object holds an instance of Task class.  
							   This Task is used by the ScheduledJob
							*/ 	
							//create new instance of task with given task name. This constructor call takes care
							//of initializing task Id as well.
							Task  task		=	new Task();  
							// Set the Task name, This line may not require for dedicated tasks
							task.setBatchID("NewTask"+j);
							task.setBatchName("NewTask"+j); 
							task.setReportID(reportId);
							
                            //Set report output format for the delivery.  
							// This line is optional, if PDF is the required format.
							task.setReportFormat(InteraConstants.ReportFormats.PDF);
							//Creates HashMaps to  get the parameters from the reports
							HashMap 	hmInputParam	=	new HashMap();
							//This HashMap to get the report parameters
							HashMap hmRepParams = new HashMap();
							//This Hash map to getthe system parameters
							HashMap hmSysParams = new HashMap();
							//The hash map of system parameters  containing the key as REPORT_ID and value the report id.							
							hmSysParams.put("REPORT_ID",reportId);
							//Now the inputParam hashmap will have the hash maps containing both the report parameters and the system parameters.
							hmInputParam.put(com.intellica.client.common.InteraConstants.SYS_PARAMS,hmSysParams);
							hmInputParam.put(com.intellica.client.common.InteraConstants.REPORT_PARAMS,hmRepParams);
							//This method returns the vector of InputParam required for the requested report. 
							//Syntax: public java.util.Vector getInputParameters(java.lang.String reportId,
							//                                 java.util.HashMap allParams,UserInfo userInfo)

							//@Param : reportId - Report Id for getting the UPX.
							//@Param : allParams - HashMap containing different HashMaps for different type of parameters System Parameter with
							//         com.intellica.client.common.InteraConstants.SYS_PARAMS as key.
							//         User Parameters with com.intellica.client.common.InteraConstants.REPORT_PARAMS as key.
							//@Param : userInfo - UserInfo object contains the information relating to the database user
							Vector vecInputParams	=	lm.getInputParameters(reportId, hmInputParam, userInfo);
							
                            //Creates a user hash map to retrieve the the parameters from the vector .
							HashMap userHMap = new HashMap();
								
							for (int i = 0; i< vecInputParams.size(); i++)
							{
								        InputParam ip = (InputParam)vecInputParams.elementAt(i);
								        //This will set parameter name and its default value
								        userHMap.put(ip.getName(),ip.getDefaultValue());
															       
							}
							//Creating HashTable object to put the user hash map informations.			
							Hashtable userMapTable	=	new Hashtable();
							userMapTable.put(InteraConstants.REPORT_PARAMS,userHMap);
							 	
							 //set userMapTable in task
							 //Syntax: public void setUserParam(java.util.Hashtable userHashParam)
							 task.setUserParam(userMapTable);
							
										
							//set whether the task is public or private
							task.setIsPublic(false);
												
							//set whether the task is shared or dedicated
				     		task.setIsShared(false);
								
																				
				     		//set Delivery operation type to Email
							task.setDeliveryOperationType(com.intellica.client.common.Enums.Batch.DispatchOperationTypes.EMAIL);
											
							// get EmailProperty object for setting Email attributes
							EMailProperty  eMailProp	=	task.getEMailProperty();
								
							//We need the report output to be attached to the mail.
							eMailProp.setMailAttach(true);
								
							// Set the Email to this address. For multiple address separate them by , or ;
							eMailProp.setMailTO("HostUser@HostOrg.com");
								
							// Set the subject of mail
							eMailProp.setMailSUB("Mail Subject goes here"); 	
													
							// This can be used to set Email message.
							// Email message can be set in the text file(\ReportEngine\config\attachemailmessage.txt)
							// This text file can have HTML messages also.(HTML tags needs to be strictly matching)
							// comment out the eMailProp.setMailMSG call for server to take message from attachemailmessage.txt
							eMailProp.setMailMSG("Dear User, Please find  <%Report_Name%>  attached");
							// If need to CC mail
							eMailProp.setMailCC("HostUser@HostOrg.com");
							// If need to BCC mail
							eMailProp.setMailBCC("HostUser@HostOrg.com");
								
							/* create a SCHEDULEDJOB with the above ReportDeliveryTask and Schedulefrequency.
								 ScheduledJob object takes instance of task and schedule objects.
					        */
						    ScheduleJob	schdJob		=	new ScheduleJob();
						
							// This name can be used to display in list
							schdJob.setJobName("NewJob"+j);
																	
							// Attach Task Object with the Schedule Job
							schdJob.setTaskObj(task);
								
							//Set is shared
							schdJob.setIsShared(false);
								
							// Set Job types ONCE
							schdJob.setRunType(Enums.ScheduledJob.JobTypes.ONCE);
								
							// Set the Date(Format mm/dd/yyyy) for the Schedule Job to run
							String date="01/10/2008";						
							schdJob.setOnceDate(date);
								
                            //Set the Time (Format hh:mm:ss) for the Schedule Job to run
							String time="16:20:20";
							schdJob.setOnceTime(time);
															
							//set whether the schedule job is public or private
				            schdJob.setIsPublic(false);

				            //set whether the schedule job is shared or dedicated
				            schdJob.setIsShared(false);
								
								
						    // Set support staff mail id for sending mail when schedule executed successfully.
							schdJob.setOnSuccessMailTo("successId@HostOrg.com.com");
								
							// Set support staff mail id for sending mail when schedule failed to execute.
							schdJob.setOnFailureMailTo("failureId@HostOrg.com.com");	
												
									
							// This will add the ScheduleJob to Intellicus Repository	
							schdMgr.addScheduleJob(schdJob,userInfo);
													
						}
					}
				}
				catch(InterfaceInitException iie)
				{
					iie.printStackTrace();
				}
			
				catch(SchedulerException se)
				{
					se.printStackTrace();
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}
			}
	
	
}
