/*This Java API is used to check whether the Report Server is running on the specified IP and Port or not.
 * User would require to use following Intellicus jar files for using Intellicus APIs:
 * 1) intellica.jar
 * 2) log4ij.jar
 * 3) xercesImpl.jar
 * 4) xmlParserAPIs.jar
 * Place above jar files in the classpath of your application.
 * These jar files are located at  :  <Install_Path>\Intellicus\APIs
 */


/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/
 

// Import Section
// Use intellica jar to import these classes
//import java.lang.Thread;
import com.intellica.client.init.ReportClient; // Has Init Method
import com.intellica.client.exception.ErrorMap;//defines enums for different messages.
import com.intellica.client.security.SecurityManager;// Has user management methods
import com.intellica.client.exception.ISecurityException;// Thrown as and when connecttion fails to report server or when user management fails
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error in initializing the report Engine interface (REInterface). 

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

/*
 * This class
 * 1) Initializes report client first,
 * 2) checks if report server running on the specified IP and Port
 */
public class TestServerConnectivity{

	public static void main(String args[]) {
					
			
		try	{
					
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
		}
		catch(InterfaceInitException iie) {
			iie.printStackTrace();
		}catch(IOException ioe){
			ioe.printStackTrace();			
		}
		
			    
	   try {		
					
		    // Create a Security controller class object using its factory 
			// for user management related operations
			SecurityManager sMgr =SecurityManager.getInstance();
			
		    
		    boolean securityMode 	= false;
			
			//If it gives Exception, then failed to connect Report Server .
			securityMode=sMgr.getSecurityMode();
	   }
					
	   catch(ISecurityException ise) {
			if(ise.getErrCode()==ErrorMap.E_NS_CONNECTIONG_TO_SERVER){
			   System.out.println ("Failed to Connect to report server");
		    }
		    
	   }
			 
    }
	
		
}		

