// This program 
// 1) delete user with this given userId,  
//The user would require to provide its identity i.e. user Info to authorize for managing Users.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 **/
 // Import Section
// Use intellica jar to import these classes

import com.intellica.client.init.ReportClient; // Has Init Method
import com.intellica.client.common.UserInfo; // Object used to pass in run report
import com.intellica.client.security.SecurityManager;// Has user management methods
import com.intellica.client.exception.ISecurityException;// For exceptions during user management
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any 
                                                             //error in initializing the report Engine interface (REInterface). 

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class deletes the user with given user id.The requestor user who wants to delete any user required to have the rights to
//delete.

public class DeleteUser
{

	public static void main(String args[])
	{
		
		try
		{
						
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
			
			// Prepare a requestor user info bean object.
			// This user should be present in Intellicus application.
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String adminUserId = "Admin";
			String adminPassword = "Admin";
			String adminOrganization = "Intellica";
			UserInfo requestorUserInfo	=	new UserInfo(adminUserId,adminPassword,adminOrganization);
		
			
			// Create a Security controller class object using its factory 
			// for user management related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager getInstance()
			SecurityManager sMgr =SecurityManager.getInstance();
			
			
			// prepare new user info			
			String userId="FinanaceUser";
			String orgId="FinanceOrg";//Organization Id in which user exists.
			// Prepare a Target user info bean object.
			//This will used to get user Information.
			//Syntax: public UserInfo getUserById(java.lang.String userId,java.lang.String orgId,
            //        UserInfo userInfo)
					
			UserInfo targetUserInfo=sMgr.getUserById(userId,orgId,requestorUserInfo);
							
			// Create a User Info Object for Deleting a existing user
			//Syntax : public void deleteUser(UserInfo targetUInfo,
            //         UserInfo userInfo) 

			//@param targetUInfo - The UserInfo object containing the changed details of user 
			//@param userInfo    - The current user details who is providing access rights 
			//					   to the specified user.
				
			sMgr.deleteUser(targetUserInfo,requestorUserInfo);
												
			
			}
			
			catch(InterfaceInitException iie)
			{
		    	System.out.println ("Could not connect to report server::");
				iie.printStackTrace();
			}
			catch(ISecurityException ise)
			{
				System.out.println ("Failed to add a new user::");
				ise.printStackTrace();
			}
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    }
	}
	
	
	
}		
