// This program will return user info object for the given userid. 
//The user would require to provide its identity i.e. user Info to get authorized for performing 
//User Management related ativities.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
 ***/



// Import Section
// Use intellica jar to import these classes
import com.intellica.client.init.ReportClient;//Has Init method.
import com.intellica.client.security.SecurityManager;// Has mser management methods
import com.intellica.client.common.UserInfo;// user info bean 
import com.intellica.client.exception.ISecurityException;// Exception class for all security related operations.
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error

                                                             // in initializing the report Engine interface (REInterface).import com.intellica.client.init.ReportClient; // Has Init Method
import java.util.ArrayList;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class will return the user for a given userId.And administrator can perform a lot 
//of manipulation on that organisation.
public class GetUserById
{

	public static void main(String args[])
	{
		
		try{

			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);
				
				// Prepare a requestor user info bean object.
				// This user must have Admin rights to perform user management actions
				// such as create user
				//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
				//@param userId   - : Id of the User Logged-In.
				//@param password - : Password of the User Logged-In.
				//@param orgId    - : Organization Id from which User Logged-In.
				String adminUserId = "Admin";
				String adminPassword = "Admin";
				String adminOrganization = "Intellica";
				UserInfo requestorUserInfo	=	new UserInfo(adminUserId,adminPassword,adminOrganization);
			
				// Create a Security controller class object using its factory 
				// for user management related operations
				//public getInstance method to access the static instance of SecurityManager object
				//Syntax public static SecurityManager getInstance()
				SecurityManager sMgr =SecurityManager.getInstance();
			
								
				String orgId="Test";//Organization Id in which user exists.
				
				String userId="FinanceUser";
				//This will used to get user Information.
				//Syntax: public UserInfo getUserById(java.lang.String userId,java.lang.String orgId,
                //        UserInfo userInfo)
				UserInfo userInfoObj=sMgr.getUserById(userId,orgId,requestorUserInfo);
				//Retrieving information about the organisation in which the user exists,the description about 
				//the user ,the organisation id and the user id.
				System.out.print("Organization   :    " +userInfoObj.getOrganization());	
				System.out.print("\nDescription   :   " +userInfoObj.getDescription());	
				System.out.print("\nOrganizationId :  " +userInfoObj.getOrgID());
				System.out.print("\nUserId   :        " +userInfoObj.getUserId());	
				System.out.print("\n");	
			}
			catch(InterfaceInitException iie)
			{
			System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
			//	iie.printStackTrace();
			}
			catch(ISecurityException ise){
				System.out.println("Error Message:"+ise.getExtMessage());
				
			}
					
			
			catch(Exception e)
			{
				e.printStackTrace();
			}		
	
	

	} // End of main function
	
	
	
}		
