// This program will map the host application user with Intellicus user
//The user would require to provide its identity i.e. user Info to authorize for User Mapping activities.

//User would require to use following Intellicus jar files for using Intellicus APIs:
//1) intellica.jar
//2) log4ij.jar
//3) xercesImpl.jar
//4) xmlParserAPIs.jar
//Place above jar files in the classpath of your application.
//These jar files are located at  :  <Install_Path>\Intellicus\APIs

/***
 * DISCLAIMER OF WARRANTY
 * This source code is provided "as is" and without warranties as to performance or merchantability. 
 * 
 * This source code is provided without any express or implied warranties whatsoever
 *
**/

// Import Section
// Use intellica jar to import these classes

import com.intellica.client.init.ReportClient;        // Has Init Method
import com.intellica.client.common.UserInfo;          // user info bean 
import com.intellica.client.exception.ISecurityException;// Exception class for all security related operations.
import com.intellica.client.exception.InterfaceInitException;//Thrown as and when there is any error
// in initializing the report Engine interface (REInterface). 
import com.intellica.client.security.SecurityManager; // Has user management methods

import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;

//This class maps the Intellicus user to an application user.
public class UserMapping
{

	public static void main(String args[])
	{
		
		try
		{
						
			// Static Init call. it will read the properties for report server related attributes 
			// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
			//in the INTERA_HOME property of the ReportClient.properties file.
			InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
			ReportClient.init(is);

			
			// Prepare a requestor user info bean object.
			// This user must have Admin rights to perform user management actions
			// such as create user
			//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
            //@param userId   - : Id of the User Logged-In.
            //@param password - : Password of the User Logged-In.
            //@param orgId    - : Organization Id from which User Logged-In.
			String adminId = "Admin";
			String adminPassword = "Admin";
			String adminOrganization = "Intellica";
			String userId="user1";
			String userPassword="";
			String userOrganisation="userOrg";
			UserInfo 		 userInfo	=	new UserInfo(userId,userPassword,userOrganisation);
			UserInfo 		 adminUserInfo	=	new UserInfo(adminId,adminPassword ,adminOrganization);
			
			// Create a Security controller class object using its factory 
			// for user management related operations
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager getInstance()
			//public getInstance method to access the static instance of SecurityManager object
			//Syntax public static SecurityManager getInstance()
			SecurityManager sMgr =SecurityManager.getInstance();
			String newUserId="newUser";
				
				//  Map intellicus user to the host application	user
				//  map User (Aplplication user id string, 
				//                         user info of intellicus user to be mapped 
				//                                 , requestor admin user)
				//  assuming we are mapping chris1 to chris1
				//@param requestorUserInfo - The current user details who is providing access rights 
				//					         to the specified user.
			 
				//@param addUserInfo - The user info of the user that is to be added.
				sMgr.mapAppIdToUser(newUserId, userInfo, adminUserInfo);
			}
			catch(InterfaceInitException iie)
			{
			System.out.println ("Could not connect to report server::"+iie.getErrorMessage());
			//	iie.printStackTrace();
			}
			catch(ISecurityException ise){
			    System.out.println ("::Failed to Map user::");
				ise.printStackTrace();
		   }		
		
		catch(Exception e)
		{
			System.out.println ("Exception caught");
			e.printStackTrace();
		}
		
	} // End of main program
}		

