//Imports required for the sustainance of this class.
import com.intellica.client.common.InteraConstants;
import com.intellica.client.common.UserInfo;
import com.intellica.client.exception.InterfaceInitException;
import com.intellica.client.exception.PersonalizationHandlerException;
import com.intellica.client.init.ReportClient;
import com.intellica.client.personalization.PersonalizationManager;
import com.intellica.client.personalization.Preferences;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

/*This Class is to set the Preferences for a particular User by the Admin.
 * */
public class UserPrefSetByAdmin {
public static void main(String args[]){
	
	try{

		// Static Init call. it will read the properties for report server related attributes 
		// like server IP/Port and to create the logs at some desired location, set the absolute or the relative path where to create the logs 
		//in the INTERA_HOME property of the ReportClient.properties file.
		InputStream is= new BufferedInputStream(new FileInputStream("<ReportClient.properties_Absolute Path>"));//Replace by <ReportClient.properties_Absolute Path> 
																														//with the absolute path of ReportClient.properties.
		ReportClient.init(is);

      	// Prepare a requestor user info bean object.
		// This user should be present in Intellicus application.
		//Syntax public UserInfo(java.lang.String userId,java.lang.String password,java.lang.String orgId)constructor for creating UserInfo instance 
        //@param userId   - : Id of the User Logged-In.
        //@param password - : Password of the User Logged-In.
        //@param orgId    - : Organization Id from which User Logged-In.
		String adminUserId 		 = "Admin";
		String adminPassword 	 = "Admin";
		String adminOrganization = "Intellica";
		UserInfo adminUserInfo	 =	new UserInfo(adminUserId,adminPassword,adminOrganization);
		
		//The id of the organization in which the user (whose preference is to be set)exists.
		String organizationId="Intellica";
		//The User id for which you want to set preferences.
		String userId="Admin";
		
			
		PersonalizationManager pManager = new PersonalizationManager();
		//Variable for keeping details of user prefs
		Preferences userPref = new Preferences();
		 // if userpref not null get user preference details to populate the user preferences in html
		if(userPref != null) {
			/* public void setDefaultPortalTheme(java.lang.String defaultPortalTheme)
			 * @Parameters:defaultPortalTheme - The string containing the user's 
			 * preferred default-portal-theme
			 * Set the default theme for the user*/
			userPref.setDefaultPortalTheme("Default");
			/*public void setPrefLanguage(java.lang.String prefLanguage)
			 * @Parameter:prefLanguage - The string containing the user's preferred language
			 *  Set the default Language for the user*/
			userPref.setPrefLanguage("hi_IN");
			/*public void setTimeZone(java.lang.String timeZone)
			 * @Parameters:prefTimeZone -String Time zone
			 * Set the default TimeZone for the user*/
			userPref.setTimeZone("US/Samoa");
			/*public void setFormat(java.lang.String format)
			 * @parameters:format - The string containing the report format
			 * Set the Report  Format for the user*/
			userPref.setFormat(InteraConstants.ReportFormats.PDF);			
            /*public void setTemplateName(java.lang.String templateName)
             * @parameters:templateName - String Name of template
             * Set adhoc template name*/
            userPref.setTemplateName("Beach");
			/*public void setReportCount(int reportCount)
			 * @Parameters:reportCount - The number of report recent reports to be shown.
			 * Set the default value of Report Count for the user*/
			userPref.setReportCount(8);
			/*This Method sets default use email for name to be used for all reports 
			 * public void setUseEmailFor(java.lang.String useEmailFor)
			 * @Parameters:useEmailFor - String Use Email For
			 * For normal users,paramter useEmailFor can be folllowing:
			 * 0-Approval Process
			 *1-Asynchronous Report Completion
			 *0,1-All,Approval Process,Asynchronous Report Completion(seleting all the three)
			 *
			 *For Admin User,paramter useEmailFor can be folllowing:
			 *0,1- Approval Process
			 *Asynchronous Report Completion
			 *	0-Approval Process
			 *	1-Asynchronous Report Completion
			 *	2-Memory Trigger
			 *	3-Request Rejection on Memory Trigger 
			 *	2,3- Fault Tolerance,Memory Trigger,Request Rejection on Memory Trigger  
			 *  0,1,2,3-For all the options to be seleted
			 **/
			userPref.setUseEmailFor("0,1,2,3");
			/*public void setEmail(java.lang.String email)
			 * @Parameter:email - The Email address of the user
			 * Method set the email address of the user */
			userPref.setEmail("Host@yahoo.co.in");
			/*public void setOwnerOrgId(java.lang.String ownerOrgId)
			 * Method sets the ownerOrgId attribute for the report.
			 * Parameters:ownerOrgId - : Id of the organization for which 
			 * the preferences is to be set.
			*/
			userPref.setOwnerOrgId(organizationId);//Mandatory to provide the owner organization id 
			/*public void setOwnerAppId(java.lang.String ownerAppId)
			 * @Parameters:ownerAppId - :User Id whose preference is to be set.
			 * Method sets the ownerAppId attribute for the report. */
			userPref.setOwnerAppId(userId);	
			//Set the default Working Folder for the user
			//public void setWorkingFolder(java.lang.String workingFolder)
			/*Method sets preferred/Working Folder of the user. 
			Parameters:
			workingFolder - - user's preferred/working Folder(The category Id is required to be set here)*/
			userPref.setWorkingFolder("4F9245A7-D639-4F99-604D-F32641B77725");//category Id
			/* public void setDefaultConnection(java.lang.String defaultConnection)
			 * @Parameters:defaultConnection - The defaultConnection to set.
			 * set the default Connection set by the user for Organization Preferences*/
			//userPref.setDefaultConnection("Default");
			/*public void setType(java.lang.String type)
			 * @Parameters:Parameters:ownerAppId - : AppId who own the report.
			 *Method sets the ownerAppId attribute for the report. 
			 * */
			userPref.setType("USER");
			/*public Preferences updateUserPreferences(Preferences userPref,
            *                           UserInfo userInfo)
            *                     throws PersonalizationHandlerException  
            *   Parameters:userPref - The user preferences prefernces details
            *	userInfo - userInfo object for authorization. 
            *	Returns:Preferences 
            *	Throws: PersonalizationHandlerException   
            *	Method update the user preferences to the repository.
            **/
			pManager.updateUserPreferences(userPref, adminUserInfo);
		}
	}catch(InterfaceInitException 	iie){}
	catch(PersonalizationHandlerException phe){}
	catch(IOException ioe){}
	
	}
}

